-*- coding: utf-8 -*-

base-url = https://github.com/ruby/ruby

commit d2edfe55e0cebf769c8a343788f56ea406b36286
  Author:     NAITOH Jun <naitoh@gmail.com>
  AuthorDate: 2025-10-13 19:29:47 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-10-17 10:32:30 +0900

    Bump rexml to v3.4.4 for Ruby 3.2 (CVE-2025-58767)

    This update addresses CVE-2025-58767 (GHSA-c2f4-jgmc-q2r5).

commit c38243e2c4e874d67b63431f9489f47ddfecdefd
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-10-05 19:38:47 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-10-09 14:00:36 +0900

    [ruby/openssl] ssl: remove OpenSSL::X509::V_FLAG_CRL_CHECK_ALL from the default store

    With OpenSSL 3.6.0, it causes nearly every certificate verification to
    fail with the message "certificate verify failed (unable to get
    certificate CRL)" because the CRLs are typically unavailable in the
    default store used by OpenSSL::SSL::SSLContext#set_params.

    OpenSSL::X509::V_FLAG_CRL_CHECK_ALL is a flag that extends the CRL
    checking to all certificates in the chain. In OpenSSL < 3.6.0, the flag
    alone has no effect, and OpenSSL::X509::V_FLAG_CRL_CHECK must also be
    set to enable CRL checking.

    In OpenSSL 3.6.0, OpenSSL::X509::V_FLAG_CRL_CHECK_ALL now implies
    OpenSSL::X509::V_FLAG_CRL_CHECK. This is inconsistent with the man page
    and may be fixed in a future OpenSSL 3.6.x release, but this flag is not
    needed and should not be set by default.

    Fixes https://github.com/ruby/openssl/issues/949

    https://github.com/ruby/openssl/commit/e8481cd687

commit a7e80e0966bf134cba76031d97e503e8ec3eea63
  Author:     Takashi Kokubun <takashi.kokubun@shopify.com>
  AuthorDate: 2025-10-09 06:23:34 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-09 06:23:34 +0900

    post_push.yml: Backport commit-mail to ruby_3_2 (#14783)

commit b8802ae5a07ef13b1e9d473867f500feece3433e
  Author:     Takashi Kokubun <takashi.kokubun@shopify.com>
  AuthorDate: 2025-10-08 17:10:14 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-08 17:10:14 +0900

    Backport fetch_changesets to ruby_3_2 (#14774)

commit 6dbf3d931304b2adb60f9cee0d1babc0ad018487
  Author:     Takashi Kokubun <takashi.kokubun@shopify.com>
  AuthorDate: 2025-10-08 13:42:24 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-08 13:42:24 +0900

    Backport post_push.yml workflow to ruby_3_2 (#14771)

commit 6d19422887267acd4fa469619b28733325c6563c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-10-07 18:50:00 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-10-07 19:54:25 +0900

    Fix tests to verify basic authentication

commit f9b2ebc9ab8380ba9f294f4470d0b883bd4bb473
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-10-07 18:35:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-10-07 19:54:25 +0900

    Truncate x-oauth-basic strings from tests of rubygems

commit 2c01a34978b104113025d45d85eb30c1dbbea0cb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-10-07 18:27:27 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-10-07 19:54:25 +0900

    Merge URI-0.12.5

commit 94aabd3415e3251e9058089d85dfeef30c3f2dfc
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-29 00:44:44 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-08-01 10:16:55 +0900

    Correct castings to use OnigDistance

commit 0eb1ed4f26afa64d52bae070727e4c5cf11775d7
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 18:45:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-08-01 10:16:55 +0900

    Add castings to prevent warnings

commit ae966df90745f665aaf17b674f7c740e3514bd53
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 17:50:36 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-08-01 10:16:55 +0900

    Port a Oniguruma patch: Integer overflow in onig_search_gpos()

    https://github.com/kkos/oniguruma/commit/778a43dd56925ed58bbe26e3a7bb8202d72c3f3f

    It differs from the Oniguruma patch in that it dosen't use `onigenc_get_prev_char_head()`
    because this function's signature has been changed by Oniguruma and the change is not ported
    in Onigmo for now. This patch respects the current Onigmo implementation.

    Co-Authored-By: K.Kosako <kkos@users.noreply.github.com>

commit f16262e54453d6dc483db3deda5c2674d8c1d52a
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 16:18:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-08-01 10:16:55 +0900

    Port a Oniguruma patch: Integer overflow in backward_search_range() and onig_search_gpos()

    https://github.com/kkos/oniguruma/commit/bfc36d3d8139b8be4d3df630d625c58687b0c7d4

    Co-Authored-By: K.Kosako <kkos@users.noreply.github.com>

commit b2da5f3188104a1264b4291f991af1fbbc0e0c07
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 16:05:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-08-01 10:16:55 +0900

    Port a Oniguruma patch: Integer overflow in forward_search_range()

    https://github.com/kkos/oniguruma/commit/db64ef3189f54917a5008a02bdb000adc514a90a

    Co-Authored-By: K.Kosako <kkos@users.noreply.github.com>

commit 8f611e0c46012e321b39efd629eb5f4f53976863
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-24 17:24:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-24 17:27:18 +0900

    bump teeny

commit 2417ed9275eaea69fd52f83ec810d21d9486598b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-24 13:11:55 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-24 14:39:20 +0900

    Update dependencies

commit b2cd6d71bbb7e66cdb8067259ec607f270700977
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-12 10:17:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-24 14:39:20 +0900

    Cast up `int` instruction code to `VALUE`

    Fix Visual C warnings:
    ```
    iseq.c(3793): warning C4312: 'type cast': conversion from 'int' to 'void *' of greater size
    iseq.c(3794): warning C4312: 'type cast': conversion from 'int' to 'void *' of greater size
    ```

commit 2509297258b40f8b55bee252611efc28a12f2f67
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-12 10:16:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-24 14:39:20 +0900

    Separate `__has_attribute` from `defined(__has_attribute)`

    Fix Visual C warnings:
    ```
    regenc.h(121): warning C4067: unexpected tokens following preprocessor directive - expected a newline
    ```

commit e26e8423b5b8a375a8fd6412a99eb6a8cc73cf2c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-30 18:35:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-24 14:39:20 +0900

    Suppress gcc 15 unterminated-string-initialization warnings

commit 7e6bbc40c8781bff4d99f0ab2a363016bc5ffadd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-24 12:21:34 +0900

    [ruby/io-wait] Run `have_func` with the header providing the declarations

    https://github.com/ruby/io-wait/commit/48309d7877

commit 5c74f2a79bb1b184d5eea975178007e2da1816ed
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-24 12:21:34 +0900

    [ruby/json] Run `have_func` with the header providing the declarations

    https://github.com/ruby/json/commit/95fb084027

commit f82b9d8d7b29130d27f5c13aa3bdd2ed3f9a57c8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-24 12:21:34 +0900

    [ruby/strscan] Run `have_func` with the header providing the declarations

    https://github.com/ruby/strscan/commit/18c0a59b65

commit eba9fa20b5421deda53961f09dadc04f3f92ff7e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-06-12 10:32:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-24 12:21:34 +0900

    [ruby/strscan] Update extconf.rb
    (https://github.com/ruby/strscan/pull/158)

    - `have_func` includes "ruby.h" by default.
    - include "ruby/re.h" where `rb_reg_onig_match` is declared.

    https://github.com/ruby/strscan/commit/1ac96f47e9

commit 9f00b8872d3e294312c99150f1c34b6b3fa74985
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-08 16:36:33 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-09 06:18:51 +0900

    Bump up resolv-0.2.3 for Ruby 3.2

commit bd7d210d1c33d78a364d18f0c346bb63e69bb6ad
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-26 20:11:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-06-25 14:33:23 +0900

    Win: Suppress false warnings from Visual C 17.14.1

    https://developercommunity.visualstudio.com/t/warning-C5287:-operands-are-different-e/10877942?

    It is not able to silence "operands are different enum types"
    warnings, even using an explicit cast, as the message says.

commit 8eadf30cf464e040f95f9d11b832b35a96afea99
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-06-25 12:29:06 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-06-25 13:28:38 +0900

    Removed unnecessary winsdk version

commit 051e5f54ccaef1721796252af259530b82c44211
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-26 20:37:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-06-25 13:28:38 +0900

    [Bug #21255] Win32: Do not export `__declspec(selectany)` symbols

    ```
    x64-vcruntime140-ruby350.def : error LNK2001: unresolved external symbol Avx2WmemEnabledWeakValue
    ```

commit d946d65cea2468086932bb95d77ac2f93b9f67b9
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-12 14:16:06 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-06-06 08:33:30 +0900

    Detect `clock_gettime` and `clock_getres` for winpthreads

commit cce19c9c252f53a1c31c9b3962d773007e20891d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-23 14:57:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-28 10:38:11 +0900

    Fixed cache key of vcpkg installed artifacts

commit 7e3c8174694f633bccb52132321b8ef7d6f83605
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-23 14:48:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-28 10:38:11 +0900

    Don't store download cache of vcpkg

commit 161aede142c8a10f7858f79549bf9d66ac107fcd
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-21 17:39:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-23 07:39:44 +0900

    Disabled TRAP cache of CodeQL

commit 5862be0e89260e597d3dd3d350e7ecb40ee62cce
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-22 15:27:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-22 18:32:10 +0900

    Skip failing tests with mingw platform

    https://github.com/ruby/ruby/actions/runs/15159221855/job/42621232822?pr=13397

    ```
      1)
      File.atime returns the last access time for the named file with microseconds FAILED
      Expected 0 == 123456
      to be truthy but was false
      D:/a/ruby/ruby/src/spec/ruby/core/file/atime_spec.rb:26:in `block (3 levels) in <top (required)>'
      D:/a/ruby/ruby/src/spec/ruby/core/file/atime_spec.rb:3:in `<top (required)>'

      2)
      File.ctime returns the change time for the named file (the time at which directory information about the file was changed, not the file itself) with microseconds. FAILED
      Expected 0 > 0
      to be truthy but was false
      D:/a/ruby/ruby/src/spec/ruby/core/file/ctime_spec.rb:21:in `block (3 levels) in <top (required)>'
      D:/a/ruby/ruby/src/spec/ruby/core/file/ctime_spec.rb:3:in `<top (required)>'

      3)
      File.utime sets the access and modification time of each file FAILED
      Expected 2025-05-21 10:30:54 +0000
      to be within 2025-05-21 10:30:54 +0000 +/- 0.0001
      D:/a/ruby/ruby/src/spec/ruby/core/file/utime_spec.rb:25:in `block (2 levels) in <top (required)>'
      D:/a/ruby/ruby/src/spec/ruby/core/file/utime_spec.rb:3:in `<top (required)>'

      4)
      File.mtime returns the modification Time of the file with microseconds FAILED
      Expected 0 == 123456
      to be truthy but was false
      D:/a/ruby/ruby/src/spec/ruby/core/file/mtime_spec.rb:25:in `block (3 levels) in <top (required)>'
      D:/a/ruby/ruby/src/spec/ruby/core/file/mtime_spec.rb:3:in `<top (required)>'
    ```

    It may be fixed with https://github.com/ruby/ruby/commit/7aea269b89bd7024bcacb7fe7d4ddb0be2f215af.
    But Ruby 3.2 is now security maintenance status. We can't backport it.

commit b7aca78cee41f59d7724c9fff7805dcb4f9411e1
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-06-21 16:00:16 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-22 18:32:10 +0900

    [ruby/io-console] Use gperf 3.1 to generate ANSI-C code

    https://github.com/ruby/io-console/commit/3798aae42d

commit c239069d07c860e5b01ca139cf322b7535405686
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-11 14:47:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-22 18:32:10 +0900

    Fix redefinition of `clock_gettime` and `clock_getres`

    winpthreads-git 12.0.0.r720 provides `clock_gettime` and
    `clock_getres` as inline functions.

commit 395e5de8d47fe61da470c45bc20be7bfe66e07c0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-21 18:16:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-22 18:32:10 +0900

    Update the latest version of ruby/setup-ruby

commit f91480d7a671b1b114270a4b5e4d3c5aa6dabce9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-13 11:20:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-13 11:22:38 +0900

    merge revision(s) 719486a642f0e282b02b958069b8b39b85b3aa1e: [Backport #21286]

            Fix C23 (GCC 15) WIN32 compatibility for rb_define_* functions

            Fixes [Bug #21286]

commit b133b39705a862cb14df216560e2babb680c6aa6
  Author:     nick evans <nick@rubinick.dev>
  AuthorDate: 2025-05-01 02:01:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 20:33:38 +0900

    Bump net-imap to v0.3.9 for Ruby 3.2 (CVE-2025-43857)

    This update addresses CVE-2025-43857 (GHSA-j3g3-5qv5-52mj).

commit d274682728d68f06b16e638dec23452de30b833b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 13:37:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 14:19:08 +0900

    Use system vcpkg command for windows-2022 image

commit 9597813f9dda4cbb12a7998bfcccff86dbf1d500
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 12:10:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 14:19:08 +0900

    Bump up the latest version of actions

commit 09a5f7a4f39cb3712084a7c2344b98ba28a914df
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-01-16 18:02:16 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 14:19:08 +0900

    Use configu.guess with wasi compatible version

commit 42a993a9b4fde86b9c664d28f83fdf5ce2c56d48
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 11:53:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 14:19:08 +0900

    Bump up clang-14 with mjit-bindgen job

commit ac91a472062a5e627a0f3a961408f66fd3f7cfb4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 11:52:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 14:19:08 +0900

    Removed unused auto_request_review

commit 3ae7535a4e2a4ce8ca75fd025682cd2bf4f7b6f5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 11:44:01 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 14:19:08 +0900

    Use windows-2022 because windows-2019 is EOL at June 2025

commit f274a4ea42fbee2c8d682edf5871f8dc4f30290e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 11:42:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 14:19:08 +0900

    Bump up clang-14 with yjit-bindgen job

commit a4b4e86a19b7ef5ed2b327414f087261ef3bda3e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 11:41:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 14:19:08 +0900

    ubuntu-20.04 is retired

commit 647e1ff938318615b69eb22f8eb8035510a20372
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 19:30:24 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-04 07:38:56 +0900

    Use EnvUtil.apply_timeout_scale

commit fa95d1b0b8f69625cfac0843d02b9cff6cae01dd
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 19:07:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-04 07:38:56 +0900

    Extend open_timeout for test failure on s390x

    https://rubyci.s3.amazonaws.com/s390x/ruby-master/log/20250403T060004Z.fail.html.gz

commit b79909fc5ab0979eabb3d04c5d58388e760197c6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 18:57:46 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-03 19:36:39 +0900

    Followed up 7c400c66c9

commit 7c400c66c9b30f5cbc40b37a7fb1feb7d2d31c63
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 14:18:55 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-03 14:44:09 +0900

    Use IPv4 for test server because TestNetHTTPS is failing with s390x

    https://rubyci.s3.amazonaws.com/s390x/ruby-3.2/log/20250403T005659Z.fail.html.gz

commit 105d9da252669fd80803e40b0348edd0974ff502
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 09:40:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-03 14:10:36 +0900

    Enforce to use CMake 3 because CMake 4 is not compatible to build libyaml via vcpkg

commit d75d4275e421cecf2485fb110273592359336117
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-01 15:20:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-02 10:37:08 +0900

    [rubygems/rubygems] Bump up minimum required version for cmake 4

    https://github.com/rubygems/rubygems/commit/3e77caeddf

commit 13f495dc2c98d0762d9af37e7143d2e2a07d9926
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-26 13:18:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-26 13:18:02 +0900

    bump teeny

commit a56c2fb37559bc2df39f9930d6174f8f82f65313
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-21 02:19:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:24:21 +0900

    [rubygems/rubygems] Support git 2.49

    One error message that we parse is now slightly different.

    https://github.com/rubygems/rubygems/commit/758528791d

commit 469a0a4a08dc4b3d3b6387b1f569108cc0750f17
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-13 13:34:24 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 14:27:06 +0900

    merge revision(s) da4464b824857d7610f9865ceb452ce0ead49164: [Backport #19426]

            [Bug #19426] Fix endless `Range#step` with `#succ` method

commit 998c26cd28e225b701aee00ad8f91694ba7d383a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-13 13:29:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 14:27:06 +0900

    merge revision(s) 79eb75a8dd64848f23e9efc465f06326b5d4b680: [Backport #20025]

            [Bug #20025] Check if upper/lower before fallback to case-folding

commit 774e3f0003ac53d604fb5dd080faf9cb41c21bcd
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-13 13:28:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 14:27:06 +0900

    merge revision(s) 08b3a45bc97c835b4677bf76dbce68fd51d81897: [Backport #21180]

            Push a real iseq in rb_vm_push_frame_fname()

            Previously, vm_make_env_each() (used during proc
            creation and for the debug inspector C API) picked up the
            non-GC-allocated iseq that rb_vm_push_frame_fname() creates,
            which led to a SEGV when the GC tried to mark the non GC object.

            Put a real iseq imemo instead. Speed should be about the same since
            the old code also did a imemo allocation and a malloc allocation.

            Real iseq allows ironing out the special-casing of dummy frames in
            rb_execution_context_mark() and rb_execution_context_update(). A check
            is added to RubyVM::ISeq#eval, though, to stop attempts to run dummy
            iseqs.

            [Bug #21180]

            Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

commit f89a334b555d9f91f0bb5a7c58b3097960dd7fb8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-13 13:26:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 14:27:06 +0900

    merge revision(s) bccec7fb468ad977be75e7e4c2644b4ea845ab0c, 5f8ebcada099351acbc22db264e7cd3773c2bdc4, e13575bb7938e9e5b6a79bfca1b3793123f479da, 4adcfc8cd7a17593a6590025da2b03eebf4fd63c: [Backport #19584]

            Fix crash in rb_gc_register_address

            [Bug #19584]

            Some C extensions pass a pointer to a global variable to
            rb_gc_register_address. However, if a GC is triggered inside of
            rb_gc_register_address, then the object could get swept since it does
            not exist on the stack.

            [Bug #19584] Register global variable address before assignment

            [Bug #19584] Register global variables before assignment

            [Bug #19584] [DOC] Tweek description of `rb_gc_register_address`

commit 2c4951329122143b5e0375caf1d4481173e403cb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-12 18:35:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 14:27:06 +0900

    it is not working with Ruby 3.2

commit 64d93539e78fc3c8c4527dded8f7f4288f7ff1ae
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-12 18:15:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 14:27:06 +0900

    Merge strscan-3.0.7

commit 30379fa1e25c2dbc887e5ee80ddd601bfdd9f20b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-12 18:14:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 14:27:06 +0900

    Merge strscan-3.0.6

commit 6dd8bd0d9090d0a347b90479d441884fcaa1629a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-12 18:09:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 14:27:06 +0900

    merge revision(s) f423f6e10c0c226dfed98e7cb7a5d489191dfa35: [Backport #21131]

            Ensure IO.copy_stream buffer is an independent string

            Otherwise, changes to the buffer by the destination write method
            could result in data changing for supposedly independent strings.

            Fixes [Bug #21131]

commit 1c9af6c10f97c0b612492fa63842c78ea2b8da56
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-12 18:08:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 14:27:06 +0900

    merge revision(s) d4a1a2780c39bc648496ac92fc6e6ce2eb38ab47: [Backport #21032]

            rb_feature_p: skip `get_expanded_load_path` for absolute paths

            Ref: https://github.com/fxn/zeitwerk/pull/308

            ```ruby
            require 'benchmark'

            $LOAD_PATH << 'relative-path'

            autoload :FOO, '/tmp/foo.rb'

            puts Benchmark.realtime {
              500_000.times do
                Object.autoload?(:FOO)
              end
            }
            ```

            The above script takes 2.5 seconds on `master`, and only
            50ms on this branch.

            When we're looking for a feature with an absolute path, we don't
            need to call the expensive `get_expanded_load_path`.

commit 0ef3411b98823a1cd12fda5209f09b5242a41562
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-12 17:56:55 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 14:27:06 +0900

    merge revision(s) 647390308239fbf82d159ecd83ed8df090af518d: [Backport #18257]

            [Bug #18257] Register the class path of FrozenCore to mark

            ICLASS does not have the path usually, so it needs to be registered
            separately.

commit f7ec9546ee07298f5d0aed6fc245e2405fe950bc
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-10 15:48:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-10 15:48:58 +0900

    merge revision(s) 3f07bc76ff6a11232d9f18e5eaa31835c195e8f0, 34098b669c0cbc024cd08e686891f1dfe0a10aaf: [Backport #21144]

            [Bug #21144] Win32: Use Windows time zone ID if TZ is not set

            If the TZ environment variable is not set, the time zone names
            retrieved from the system are localized for UI display and may vary
            across editions and language packs for the same time zone.
            Use the time zone IDs that are invariant across environments instead.

            [Bug #21144] Win32: Convert the time zone name to the current locale

            The Windows time zone IDs provided by Microsoft as of 24H1 are ASCII
            only all, but the API itself is not impossible to set non-ASCII key
            name.  Prefer the current locale encoding for now until we move to
            UTF-8 including environment variables and command line arguments.

commit d635eb5156e07101a62217d5f70d9d080fb96f1f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-10 15:48:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-10 15:48:27 +0900

    Update the latest version of redmine-backporter.rb and merger.rb

commit bb6b3c98dc06b92c48928d8c7f942b3dfd990089
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-03-06 07:21:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-06 11:05:43 +0900

    Replace tombstone when converting AR to ST hash

    [Bug #21170]

    st_table reserves -1 as a special hash value to indicate that an entry
    has been deleted. So that that's a valid value to be returned from the
    hash function, do_hash replaces -1 with 0 so that it is not mistaken for
    the sentinel.

    Previously, when upgrading an AR table to an ST table,
    rb_st_add_direct_with_hash was used which did not perform the same
    conversion, this could lead to a hash in a broken state where one if its
    entries which was supposed to exist being marked as a tombstone.

    The hash could then become further corrupted when the ST table required
    resizing as the falsely tombstoned entry would be skipped but it would
    be counted in num entries, leading to an uninitialized entry at index
    15.

    In most cases this will be really rare, unless using a very poorly
    implemented custom hash function.

    This also adds two debug assertions, one that st_add_direct_with_hash
    does not receive the reserved hash value, and a second in
    rebuild_table_with, which ensures that after we rebuild/compact a table
    it contains the expected number of elements.

    Co-authored-by: Alan Wu <alanwu@ruby-lang.org>

commit 977d711ba103f1d6b9656e891461a1c0e5cb35f8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-06 08:39:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-06 09:52:09 +0900

    Update actions/checkout and actions/cache and others

commit d6517a3ddee82a18bcf8917f8da1f56c549bcc69
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-28 15:54:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-02-28 17:02:07 +0900

    Skip VS2022 17.13.x build

    see https://github.com/ruby/ruby/pull/12830

commit 98fc456891c0dbf3b4bccdb7a89d05d485cd0b2a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-28 15:06:44 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-02-28 15:06:44 +0900

    merge revision(s) 2b6fc9ea7212543a1be26768403f59c7a759b5ea: [Backport #21092]

            [Bug #21092] Fallback variables after execonf has done

            When reading from a dummy makefile, the global variables initialized
            in `init_mkmf` may not be overridden.
            ---
             ext/extmk.rb | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

commit 9e5d68f03f6800b0ccde3bee32ac1789a1d0dc14
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-26 18:12:00 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-02-26 19:19:19 +0900

    Merge cgi-0.3.7

commit 946907f218e4bbef7f7a215962fcb7c97f94b7d3
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-26 18:11:46 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-02-26 19:19:19 +0900

    Merge uri-0.12.4

commit 164aaf6a47879db6c938fd388da8fcd83410b073
  Author:     nick evans <nick@rubinick.dev>
  AuthorDate: 2025-02-11 23:18:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-02-14 11:50:48 +0900

    Bump net-imap to 0.3.8 for Ruby 3.2 (CVE-2025-25186)

    This update addresses CVE-2025-25186 (GHSA-7fc5-f82f-cx69).

commit 02ec31524440656c4e1d3f2d84dfbd15d2c63658
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-02-04 20:33:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-02-04 20:33:29 +0900

    bump teeny

commit 7c0c2df9b497dbf9c1376a995eebe6d43a00e21b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-01-25 14:51:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-01-25 14:51:31 +0900

    merge revision(s) dd80d9b089e35729d585bae2f8866c845c48f3b7: [Backport #20997]

            YJIT: Filter `&` calls from specialized C method codegen

            Evident with the crash reported in [Bug #20997], the C replacement
            codegen functions aren't authored to handle block arguments (nor
            should they because the extra code from the complexity defeats
            optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

commit 97243cc9c76b9cc2803cfd1c01165ab5bd432450
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-01-25 14:39:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-01-25 14:39:22 +0900

    merge revision(s) 04ec07794657cd2444ecb001a522b9df2db1b90a: [Backport #21038]

            Preserve `errno` in `rb_fiber_scheduler_unblock`. (#12576)

            [Bug #21038]

            Co-authored-by: Julian Scheid <julians37@gmail.com>

commit f9adaab928dff8dd7ecd4c560c288300a3c74880
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-01-25 14:37:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-01-25 14:37:41 +0900

    merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

            Avoid opt_aset_with optimization inside multiple assignment

            Previously, since the opt_aset_with optimization was introduced,
            use of the opt_aset_with optimization inside multiple assignment
            would result in a segfault or incorrect instructions.

            Fixes [Bug #21012]

            Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

commit 845763fdf370846938b86a062827b237313c924f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-01-11 15:32:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-01-11 15:32:49 +0900

    merge revision(s) b176d4f52e4af67654814dab3e9c5f4bf9170e54: [Backport #21008]

            [Bug #21008] Normalize before sum to float

            After switching to `Float`-mode when summing `Numeric` objects,
            normalization for `Float` is still needed.

commit f150d67b7d389eb88e0cd13694d3529895d55579
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-01-11 15:30:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-01-11 15:30:06 +0900

    merge revision(s) 8034e9c3d001ca3dff124ab42972684eac8af2ae: [Backport #20995]

            [Bug #20995] Protect `IO.popen` block from exiting by exception

commit 4e59c10646cf012d457da99ad258b0e6a3e42132
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-01-11 15:28:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-01-11 15:28:05 +0900

    merge revision(s) 19c39e4cfaa467e69b9848c9c5496d7f50d39c7f, d78ff6a767ca813ac5fa178dd7611f20a993c191: [Backport #20984]

            [Bug #20984] ENV.inspect should be encoding aware

            [Bug #20984] Fix test with locale encoding

commit 1d57924d693534b10699a375cb8400e57a67031c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-12-21 13:31:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-12-21 13:31:11 +0900

    merge revision(s) a1758fbd7fe7406601b0eb1617752db59b83586a:

            Crash when malloc during GC

            This feature was introduced in commit 2ccf6e5, but I realized that
            using rb_warn is a bad idea because it allocates objects, which causes
            a different crash ("object allocation during garbage collection phase").
            We should just hard crash here instead.

commit 3110d5c8abf8f710de42989fbc35870287a12f75
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-12-15 16:18:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-12-15 16:18:43 +0900

    merge revision(s) e90b447655dd39ad1eb645cdaae450efd605db00: [Backport #20924]

            [Bug #20924] Fix reading with delimiter in wide character encodings

commit 59254caff0f39c87370d0c11793e3aae5c38d6e1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-12-15 15:31:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-12-15 15:31:58 +0900

    merge revision(s) 055613fd868a8c94e43893f8c58a00cdd2a81f6d: [Backport #20447]

            Fix pointer incompatiblity

            Since the subsecond part is discarded, WIDEVAL to VALUE conversion is
            needed.

commit 303a83d35c485db626c57415b344fdd4a8d0d5e5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-12-15 15:28:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-12-15 15:28:25 +0900

    merge revision(s) 660b995365f719fa59ed6f2809bb1527e6470d14: [Backport #20915]

            [Bug #20915] Fix SEGV with `TracePoint#parameters` and aliased C method

            The following snippet results with a SEGV:

            ```ruby
            C = Class.new do
              alias_method :new_to_s, :to_s
            end

            TracePoint.new(:c_call, &:parameters).enable { C.new.new_to_s }
            ```

            at MRI 3.3.6 and ruby 3.4.0dev

            The root cause of the issue lies in the `rb_tracearg_parameters` function
            within the `RUBY_EVENT_C_RETURN` branch. Specifically, when the invoked
            method is an alias for a C function,
            `rb_method_entry_without_refinements(..., trace_arg->called_id, ...)`
            may return NULL. In that case we can fallback to `trace_arg->id`.

commit d78e1a413333bae4e70e662ac7eceb378b2a5369
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-12-15 15:26:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-12-15 15:26:55 +0900

    merge revision(s) f65a6c090c229de1665af49f2e51fc1d6397ab72: [Backport #20921]

            Fix use-after-free in constant cache

            [Bug #20921]

            When we create a cache entry for a constant, the following sequence of
            events could happen:

            - vm_track_constant_cache is called to insert a constant cache.
            - In vm_track_constant_cache, we first look up the ST table for the ID
              of the constant. Assume the ST table exists because another iseq also
              holds a cache entry for this ID.
            - We then insert into this ST table with the iseq_inline_constant_cache.
            - However, while inserting into this ST table, it allocates memory, which
              could trigger a GC. Assume that it does trigger a GC.
            - The GC frees the one and only other iseq that holds a cache entry for
              this ID.
            - In remove_from_constant_cache, it will appear that the ST table is now
              empty because there are no more iseq with cache entries for this ID, so
              we free the ST table.
            - We complete GC and continue our st_insert. However, this ST table has
              been freed so we now have a use-after-free.

            This issue is very hard to reproduce, because it requires that the GC runs
            at a very specific time. However, we can make it show up by applying this
            patch which runs GC right before the st_insert to mimic the st_insert
            triggering a GC:

                diff --git a/vm_insnhelper.c b/vm_insnhelper.c
                index 3cb23f06f0..a93998136a 100644
                --- a/vm_insnhelper.c
                +++ b/vm_insnhelper.c
                @@ -6338,6 +6338,10 @@ vm_track_constant_cache(ID id, void *ic)
                        rb_id_table_insert(const_cache, id, (VALUE)ics);
                    }

                +    if (id == rb_intern("MyConstant")) rb_gc();
                +
                    st_insert(ics, (st_data_t) ic, (st_data_t) Qtrue);
                }

            And if we run this script:

                Object.const_set("MyConstant", "Hello!")

                my_proc = eval("-> { MyConstant }")
                my_proc.call

                my_proc = eval("-> { MyConstant }")
                my_proc.call

            We can see that ASAN outputs a use-after-free error:

                ==36540==ERROR: AddressSanitizer: heap-use-after-free on address 0x606000049528 at pc 0x000102f3ceac bp 0x00016d607a70 sp 0x00016d607a68
                READ of size 8 at 0x606000049528 thread T0
                    #0 0x102f3cea8 in do_hash st.c:321
                    #1 0x102f3ddd0 in rb_st_insert st.c:1132
                    #2 0x103140700 in vm_track_constant_cache vm_insnhelper.c:6345
                    #3 0x1030b91d8 in vm_ic_track_const_chain vm_insnhelper.c:6356
                    #4 0x1030b8cf8 in rb_vm_opt_getconstant_path vm_insnhelper.c:6424
                    #5 0x1030bc1e0 in vm_exec_core insns.def:263
                    #6 0x1030b55fc in rb_vm_exec vm.c:2585
                    #7 0x1030fe0ac in rb_iseq_eval_main vm.c:2851
                    #8 0x102a82588 in rb_ec_exec_node eval.c:281
                    #9 0x102a81fe0 in ruby_run_node eval.c:319
                    #10 0x1027f3db4 in rb_main main.c:43
                    #11 0x1027f3bd4 in main main.c:68
                    #12 0x183900270  (<unknown module>)

                0x606000049528 is located 8 bytes inside of 56-byte region [0x606000049520,0x606000049558)
                freed by thread T0 here:
                    #0 0x104174d40 in free+0x98 (libclang_rt.asan_osx_dynamic.dylib:arm64e+0x54d40)
                    #1 0x102ada89c in rb_gc_impl_free default.c:8183
                    #2 0x102ada7dc in ruby_sized_xfree gc.c:4507
                    #3 0x102ac4d34 in ruby_xfree gc.c:4518
                    #4 0x102f3cb34 in rb_st_free_table st.c:663
                    #5 0x102bd52d8 in remove_from_constant_cache iseq.c:119
                    #6 0x102bbe2cc in iseq_clear_ic_references iseq.c:153
                    #7 0x102bbd2a0 in rb_iseq_free iseq.c:166
                    #8 0x102b32ed0 in rb_imemo_free imemo.c:564
                    #9 0x102ac4b44 in rb_gc_obj_free gc.c:1407
                    #10 0x102af4290 in gc_sweep_plane default.c:3546
                    #11 0x102af3bdc in gc_sweep_page default.c:3634
                    #12 0x102aeb140 in gc_sweep_step default.c:3906
                    #13 0x102aeadf0 in gc_sweep_rest default.c:3978
                    #14 0x102ae4714 in gc_sweep default.c:4155
                    #15 0x102af8474 in gc_start default.c:6484
                    #16 0x102afbe30 in garbage_collect default.c:6363
                    #17 0x102ad37f0 in rb_gc_impl_start default.c:6816
                    #18 0x102ad3634 in rb_gc gc.c:3624
                    #19 0x1031406ec in vm_track_constant_cache vm_insnhelper.c:6342
                    #20 0x1030b91d8 in vm_ic_track_const_chain vm_insnhelper.c:6356
                    #21 0x1030b8cf8 in rb_vm_opt_getconstant_path vm_insnhelper.c:6424
                    #22 0x1030bc1e0 in vm_exec_core insns.def:263
                    #23 0x1030b55fc in rb_vm_exec vm.c:2585
                    #24 0x1030fe0ac in rb_iseq_eval_main vm.c:2851
                    #25 0x102a82588 in rb_ec_exec_node eval.c:281
                    #26 0x102a81fe0 in ruby_run_node eval.c:319
                    #27 0x1027f3db4 in rb_main main.c:43
                    #28 0x1027f3bd4 in main main.c:68
                    #29 0x183900270  (<unknown module>)

                previously allocated by thread T0 here:
                    #0 0x104174c04 in malloc+0x94 (libclang_rt.asan_osx_dynamic.dylib:arm64e+0x54c04)
                    #1 0x102ada0ec in rb_gc_impl_malloc default.c:8198
                    #2 0x102acee44 in ruby_xmalloc gc.c:4438
                    #3 0x102f3c85c in rb_st_init_table_with_size st.c:571
                    #4 0x102f3c900 in rb_st_init_table st.c:600
                    #5 0x102f3c920 in rb_st_init_numtable st.c:608
                    #6 0x103140698 in vm_track_constant_cache vm_insnhelper.c:6337
                    #7 0x1030b91d8 in vm_ic_track_const_chain vm_insnhelper.c:6356
                    #8 0x1030b8cf8 in rb_vm_opt_getconstant_path vm_insnhelper.c:6424
                    #9 0x1030bc1e0 in vm_exec_core insns.def:263
                    #10 0x1030b55fc in rb_vm_exec vm.c:2585
                    #11 0x1030fe0ac in rb_iseq_eval_main vm.c:2851
                    #12 0x102a82588 in rb_ec_exec_node eval.c:281
                    #13 0x102a81fe0 in ruby_run_node eval.c:319
                    #14 0x1027f3db4 in rb_main main.c:43
                    #15 0x1027f3bd4 in main main.c:68
                    #16 0x183900270  (<unknown module>)

            This commit fixes this bug by adding a inserting_constant_cache_id field
            to the VM, which stores the ID that is currently being inserted and, in
            remove_from_constant_cache, we don't free the ST table for ID equal to
            this one.

            Co-Authored-By: Alan Wu <alanwu@ruby-lang.org>

commit 1ae2b16d0014018c99a37e3e18531cdfa5f27f06
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-03 10:02:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-03 11:04:23 +0900

    Lock json-schema-5.1.0 for using pure ruby version

commit 937319126af801016d410226eb0cefc2c0b5ed32
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-11-30 18:34:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-30 18:34:32 +0900

    merge revision(s) 02b70256b5171d4b85ea7eeab836d3d7cfb3dbfc, 6b4f8945d600168bf530d21395da8293fbd5e8ba: [Backport #20909]

            Check negative integer underflow

            Many of Oniguruma functions need valid encoding strings

commit 87249cbddb5dbac16cb7f0fa33958a42389759cb
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-11-30 14:31:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-30 14:31:31 +0900

    merge revision(s) a8c2d5e7bee5fad0965baeb58d312ddc5932ec26: [Backport #20907]

            Ensure fiber scheduler re-acquires mutex when interrupted from sleep. (#12158)

            [Bug #20907]

commit bb065f08441aab8f97b45bd3f1600202547c9532
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-11-30 14:29:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-30 14:29:18 +0900

    merge revision(s) 3b7892b6e4d1a1a5d6019987f9b46ed443dd104f: [Backport #20871]

            Fix a bug in rb_include_module that stops nested inclusion into module subclasses

            This bug was present since the code was originally added by me
            in 3556a834a2847e52162d1d3302d4c64390df1694.

            Fixes [Bug #20871]

commit 1fc0895971812d5287b23d8cbb00529e425041c0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-11-30 14:25:56 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-30 14:25:56 +0900

    merge revision(s) 0d4de0f4b1b9ac90be437bf1bac6851dd1d96fd0: [Backport #20898]

            wasm: align fiber stack pointer to 16 bytes

            In WebAssembly C ABI, the linear stack pointer must be always aligned
            to 16 bytes like other archs.
            The misaligned stack pointer causes some weird memory corruption since
            compiler assumes the aligned stack pointer.

commit d3098d2068770f8bdeca8fda06736cbebb8d3a5b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-11-21 12:14:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-22 08:06:01 +0900

    Removed extra assertions for Ruby 3.2

commit 9e1a78059dc1c2bee1159f7626a15de689f4fc1c
  Author:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  AuthorDate: 2023-11-27 15:33:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-22 08:06:01 +0900

    Fix flaky "Expected 499 to be >= 500" assertion in test_gc_compact.rb

    There have been some sproradically flaky tests related to GC compaction,
    which fail with:

      1) Failure:
    TestGCCompact#test_moving_hashes_down_size_pools [/test/ruby/test_gc_compact.rb:442]:
    Expected 499 to be >= 500.

    What's happening here, is that, _sometimes_, depending on very unlucky
    combinations of machine things, one of the expected-to-be-moved hashes
    might be found on the machine stack during GC, and thus pinned.

    One factor which seems to make this _more_ likely is that GCC 11 on
    Ubuntu 22.04 seems to want to allocate 440 bytes of stack space for
    `gc_start`, which is much more than it actually uses on the common code
    path. The result is that there are some 50-odd VALUE-sized cells "live"
    on the stack which may well contain valid heap pointers from previous
    function calls, and will need to be pinned.

    This is, of course, totally normal and expected; Ruby's GC is
    conservative and if there is the possibility that a VALUE might be live
    on the machine stack, it can't be moved. However, it does make these
    tests flaky.

    This commit "fixes" the tests by performing the work in a fiber; the
    fiber goes out of scope and should be collected by the call to
    verify_compaction_references, so there should be no references to the
    to-be-moved objects floating around on the machine stack.

    Fixes [#20021]

commit 9aa313f2f8ce2a437fe027a5d757f957b9aad5c8
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-07-31 23:26:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-22 08:06:01 +0900

    Assert that at least one element has been embedded

    It's not guaranteed that the first element will always be embedded.

commit c692229197af9088538dfd8c1234807867326e35
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-01-06 23:14:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-22 08:06:01 +0900

    Assert that resizing arrays will re-embed them

commit 605592b9becf55dab7fd00adfc9f10b9e4fa58b8
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-01-06 23:11:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-22 08:06:01 +0900

    Assert that resizing objects will re-embed them

commit ed41225edd5e5488db13785aac7180e613c07915
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2022-12-22 00:48:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-22 08:06:01 +0900

    Fix Error in GC Compaction specs

    Previously if any of the tests that move objects between size pools
    failed to move anything, then the call to stats.dig would return `nil`
    which would then cause assert_operator to error.

    This should be a test Failure, rather than an Error so this commit uses
    a default value of 0 if stats.dig fails to find a key.

    Also refactor object movement tests to use stats.dig, rather than :[]

commit 2861aa22d01a817d84842dec8cc7a57c01f96139
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-17 19:56:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-19 19:31:46 +0900

    Make `rb_ec_set_vm_stack` conformant to the C++11 requirement

    Https://learn.microsoft.com/en-us/cpp/build/reference/zc-inline-remove-unreferenced-comdat?view=msvc-140
    > If `/Zc:inline` is specified, the compiler enforces the C++11
    > requirement that all functions declared inline must have a definition
    > available in the same translation unit if they're used.

commit 0c8a3181c0ad21051a291d82cb24979bfa3bf2c4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-17 19:29:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-19 19:31:46 +0900

    Win32: Remove unreferenced COMDAT from object files

    Windows 11 SDK Version 10.0.26100.0 introduced a new internal inline
    function in ucrt/corecrt_math.h.  Even it appears in object files and
    will be included in the DEF file, it will be removed from the DLL and
    result in a linker error.

commit 3d6fe67f4237b244361a01e35b7b294297839f7d
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-17 22:49:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-19 19:31:46 +0900

    Win32: Expose wchar main routine only

    Warned if both of `main` and `wmain` are exposed:
    ```
    LINK : warning LNK4067: ambiguous entry point; selected 'mainCRTStartup'
    ```

commit e5b29c89a0f797ffad29cf436e12273fe1817d5c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-10 21:31:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-19 19:31:46 +0900

    Make `MUNICODE_FLAG` simply expanded

    It is not expected that `target_os` will change going forward.

commit 104ba2edfb1ccfa382f2312e983d16206bd2a608
  Author:     Daisuke Fujimura (fd0) <booleanlabel@gmail.com>
  AuthorDate: 2024-11-06 21:28:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-19 19:31:46 +0900

    `EXE_LDFLAGS` uses the same `MUNICODE_FLAG`

commit fba0b48c8922d819b6b4e032ed34f08bd390fc65
  Author:     Daisuke Fujimura (fd0) <booleanlabel@gmail.com>
  AuthorDate: 2024-11-06 10:01:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-19 19:31:46 +0900

    `-municode` is available for MinGW-w64 targets only

commit c71f74c346f8727dd888c135ae06fe75dcabc4d4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-04 09:39:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-19 19:31:46 +0900

    Use wide character startup

    Mingw crt-git 12.0.0.r369.g0d4221712-1 now prohibits "command line
    contains characters that are not supported in the active code page".
    https://sourceforge.net/p/mingw-w64/mingw-w64/ci/0d42217123d3aec0341b79f6d959c76e09648a1e/

    Already Ruby builds `argv` in `rb_w32_sysinit`, instead of mswin- or
    mingw-made `argv`.  Just bypass the conversion in mingw crt.

commit 1e56c26ace1f9f5b8d2189ab00bee1cd8992795e
  Author:     MSP-Greg <Greg.mpls@gmail.com>
  AuthorDate: 2024-06-21 09:33:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-19 19:31:46 +0900

    [ruby/net-http] test_https.rb - fix test_session_reuse_but_expire

    https://github.com/ruby/net-http/commit/5544243c41

commit 870e5b2b4fc786f8513ff91a623ef67a0d16f940
  Author:     Job Snijders <job@sobornost.net>
  AuthorDate: 2024-03-25 21:20:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-19 19:31:46 +0900

    [ruby/openssl] Only CSR version 1 (encoded as 0) is allowed by PKIX standards

    RFC 2986, section 4.1 only defines version 1 for CSRs. This version
    is encoded as a 0. Starting with OpenSSL 3.3, setting the CSR version
    to anything but 1 fails.

    Do not attempt to generate a CSR with invalid version (which now fails)
    and invalidate the CSR in test_sign_and_verify_rsa_sha1 by changing its
    subject rather than using an invalid version.

    This commit fixes the following error.

    ```
     2) Error: test_version(OpenSSL::TestX509Request): OpenSSL::X509::RequestError:
    X509_REQ_set_version: passed invalid argument
    /home/runner/work/openssl/openssl/test/openssl/test_x509req.rb:18:in `version='
    /home/runner/work/openssl/openssl/test/openssl/test_x509req.rb:18:in `issue_csr'
    /home/runner/work/openssl/openssl/test/openssl/test_x509req.rb:43:in
    `test_version'
         40:     req = OpenSSL::X509::Request.new(req.to_der)
         41:     assert_equal(0, req.version)
         42:
      => 43:     req = issue_csr(1, @dn, @rsa1024, OpenSSL::Digest.new('SHA256'))
         44:     assert_equal(1, req.version)
         45:     req = OpenSSL::X509::Request.new(req.to_der)
         46:     assert_equal(1, req.version)
    ```

    https://github.com/ruby/openssl/commit/c06fdeb091

commit 910d10e4eefaf89d8e6605a4603cd3a938419aae
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-11-19 17:12:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-19 19:31:46 +0900

    Update minitest-5.25.1

    5.16.3 is flaky with `make test-bundled-gems`

    https://github.com/ruby/actions/actions/runs/11898853810/job/33156475298

commit a7b013b392ca0ba4930e579f4c9e40d99d871752
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-11-10 15:15:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-10 15:15:53 +0900

    merge revision(s) d71be7274bd2623bb521be72c245c08fc38d6ae4: [Backport #20873]

            [Bug #20873] Consider `-FIXNUM_MIN` overflow

            `-FIXNUM_MIN` is usually greater than `FIXNUM_MAX` on platforms using
            two's complement representation.

commit 9bcc5c5fd9e8e4d15040eec6850b49d860eba621
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2024-10-23 11:22:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-10 15:13:24 +0900

    Fix update_coderange for binary strings

    Although a binary (aka ASCII-8BIT) string will never have a broken
    coderange, it still has to differentiate between "valid" and "7bit".

    On Ruby 3.4/trunk this problem is masked because we now clear the
    coderange more agressively in rb_str_resize, and we happened to always
    be strinking this string, but we should not assume that.

    On Ruby 3.3 this created strings where `ascii_only?` was true in cases
    it shouldn't be as well as other problems.

    Fixes [Bug #20883]

    Co-authored-by: Daniel Colson <danieljamescolson@gmail.com>
    Co-authored-by: Matthew Draper <matthew@trebex.net>

commit ee3428aa0e3a11ed1574b7d99222f6f08737f818
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-11-10 13:04:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-10 13:04:43 +0900

    merge revision(s) 56ecc243e230e8e99761ec0ffc5116601f094bb0: [Backport #20868]

            [Bug #20868] Fix Method#hash to not change after compaction

            The hash value of a Method must remain constant after a compaction, otherwise
            it may not work as the key in a hash table.

            For example:

                def a; end

                # Need this method here because otherwise the iseq may be on the C stack
                # which would get pinned and not move during compaction
                def get_hash
                  method(:a).hash
                end

                puts get_hash # => 2993401401091578131

                GC.verify_compaction_references(expand_heap: true, toward: :empty)

                puts get_hash # => -2162775864511574135

commit 288e24b73ab20100b63ae7d30fb06a7d8a19de6e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-11-10 12:31:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-10 12:55:34 +0900

    merge revision(s) 29c480dd6fca993590c82078ba797e2c4e876ac7: [Backport #20853]

            [Bug #20853] Fix Proc#hash to not change after compaction

            The hash value of a Proc must remain constant after a compaction, otherwise
            it may not work as the key in a hash table.

commit 31b58f89c682e2568c1d7b3299a13a64fbc846de
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-11-10 12:51:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-11-10 12:51:34 +0900

    backport 2a5354e59324cb296a423c73ec15ff9191086964 partially to make rb_any_hash() non-static.

commit 86fc40edfcdc57f999c5c02106ef554d73065660
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-11-06 13:59:28 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-06 15:35:34 +0900

    We should support ruby/spec with Ruby 3.1 and 3.2

commit 35bd3d110fb2b41b107423c26042c8404e295214
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-11-06 13:18:52 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-06 15:35:34 +0900

    Skip MinGW failure with GitHub Actions update

    We should fix this later

commit 2ad331acf6b7990361ead9d03382f4198206610a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-11-06 12:36:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-06 15:35:34 +0900

    Partly reverted from 449899b38314d0ecbe61e42d34398bdf2561b8e9

commit e548ff67ea1a769d79aece363fe93ce113b3a07c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-07-12 12:35:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-06 15:35:34 +0900

    Pend some tests because these are not working with macOS 15 and Xcode 16

commit 3bea0abd68172678ce9234e09a9604142d1a046b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-11-06 11:26:06 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-06 15:35:34 +0900

    Export homebrew's bison path to PATH environmental variable

commit e6ff23ef5b2fdce0a8bcafc7d71dd80abd3e73ee
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-11-06 11:14:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-06 15:35:34 +0900

    Retired macos-12 and added macos-14 and macos-15 on GitHub Actions

commit 7be9f5a6e502e3d831ffb96cda345ef3db797a26
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-11-06 10:55:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-06 15:35:34 +0900

    Fix test tail with mjit options for clang provided by Xcode 16

    ```
    clang: error: unknown argument '-emit-pch'; did you mean '-Xclang -emit-pch'?
    MJIT warning: Making precompiled header failed on compilation. Stopping MJIT worker...
    Successful MJIT finish
    ```

commit 63aeb018eb1cc0f7b00f955980711fd1bd94af7f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-10-30 18:47:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-30 18:47:11 +0900

    bump teeny

commit d09b47ddf569aeb443e3fb07b380062e825d47fc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-10-28 13:31:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-28 13:31:57 +0900

    merge revision(s) 70d20ce473952e3a2e5b0aa4a6884886517ee3cc:

            Update bundled gems list

commit e55b1af2573eb21db57a06e5509f9868f288b583
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-10-20 14:21:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-20 14:21:15 +0900

    merge revision(s) ce20367a0e2f1fcfabebf3b6bea732fc71fa79f7: [Backport #20500]

            Define `incflags` also on mswin

commit 2fbae07c42f40ea43b4822e278cc92fb2415cb61
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-10-20 14:19:52 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-20 14:19:52 +0900

    merge revision(s) bcb3247072e6973d0f6b50ca5fed238d5824bd28: [Backport #20500]

            [Bug #19778] Pass additional include options to INCFLAGS in common.mk

commit f70e3254e067663e72e6d410370d231e4245e4f4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-10-20 13:56:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-20 13:56:22 +0900

    merge revision(s) 5fa6ba9568e87e43e08a4daeba1572254c589fb1: [Backport #20500]

            [Bug #20500] Search non-default directories for jemalloc

            Co-Authored-by: lish82 (Hiroki Katagiri)

commit cb75fcef6feb126a67874109ce1503976a6f90cc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-10-18 13:10:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-18 13:57:08 +0900

    merge revision(s) 6118e8a47394409b53164b60e79fadf348b97db3, dc64448202299633a235f310b8bf2192263f274f: [Backport #20716]

            Fix method caching bug when including/prepend module A that prepends module B

            Fix by always adding the generated iclass to the subclasses list,
            otherwise the method cache for the iclass is not cleared when
            the method in the module is overwritten.

            Fixes [Bug #20716]

            Remove an unused variable

commit 087e4ed6cc9da9cfca1a107058905446ff474bd1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-10-18 13:03:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-18 13:57:08 +0900

    merge revision(s) 35e124832e29b65c84d4e0e4e434616859f9bdf5: [Backport #20755]

            [Bug #20755] Frozen string should not be writable via IO::Buffer

commit d85516eab59f932d65283572d0b9090005f60c20
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-10-01 11:39:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-18 12:59:30 +0900

    Disabled annocheck same as f5b6b3dba7b32dcd1f15c150dd78dce6c0d92b1e

commit 4873bbd6cc25311fb477bb8fe823d2ea16299717
  Author:     Jun Aruga <jaruga@redhat.com>
  AuthorDate: 2024-08-31 15:39:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-18 12:59:30 +0900

    .travis.yml: Drop all the pipelines due to jobs not starting.

    Remove `.travis.yml` as a temporary workaround.

commit dcad0ad9097583f71eac2ece22ad527305dc7bee
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-09-30 12:03:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-18 12:59:30 +0900

    -l option of 7z is unknown switch with the `ubuntu-latest`.

    https://github.com/ruby/actions/actions/runs/11095032727/job/30823174026#step:3:349

commit 5777fe5ab57d6479326bdb21ef9a6b88ea1516dc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-10-18 11:30:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-18 11:30:05 +0900

    merge revision(s) 637067440f74043c6d79fc649ab8acf1afea25a5: [Backport #20752]

            [Bug #20752] Slice of readonly `IO::Buffer` also should be readonly

commit 18074c508105244552678cf6afd4b23304cb4c8f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-10-18 11:25:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-18 11:25:12 +0900

    merge revision(s) c1862cbb89a6bf42dcd07d92fe4f4bfeebca5775: [Backport #20719]

            [Bug #20719] `Float` argument must be ASCII compatible

commit 48af30b068729058c2f45375e67fa76f6240a228
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-10-18 11:22:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-18 11:22:30 +0900

    merge revision(s) d33e3d47b84a73b38644f2a3d41881ce9be6ef18: [Backport #20704]

            [Bug #20704] Win32: Fix chdir to non-ASCII path

            On Windows, `chdir` in compilers' runtime libraries uses the active
            code page, but command line arguments in ruby are always UTF-8, since
            commit:33ea2646b98adb49ae2e1781753bf22d33729ac0.

commit 3d4d5c8d8cca0c290a234fb3c47c035822b18add
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2024-10-03 20:11:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-04 10:09:39 +0900

    Add `IO::Buffer` tests for read and write with length & offset.

commit bc482e632c99f30db2e12aa51cc3b10b3b0f7886
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2024-10-03 19:58:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-10-04 10:09:39 +0900

    Fix size calcuation when offset is given + updated documentation.

commit 2d62c5d3d9a565fe50a3582124e6d4a58d130084
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-09-26 13:00:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-09-26 13:00:19 +0900

    merge revision(s) 0d16c36d0ab2afa2ec79b72b229e69c141ebdaba: [Backport #13831]

            [win32/registry] Fallback to UTF-8 for unknown codepages

            There are some codepages like cp708 for which no ruby encoding exists:

                $ ruby -e "Encoding.find('cp708')"
                Traceback (most recent call last):
                    1: from -e:1:in `<main>'
                -e:1:in `find': unknown encoding name - cp708 (ArgumentError)

            win32/registry uses ENCODING to transcode error messages and expand environment
            variables from UTF-16LE, so using UTF-8 seems like the best choice and is better
            than a hard failure.

            This should resolve [Bug #13831]

commit b6f7d544851ee8e1f6e4d151cc915b40f8b8e4f6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-25 12:12:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-31 19:10:29 +0900

    merge revision(s) 29500e3034681a30045dea462d6bb653e8600738: [Backport #20698]

            Update bundled gems list as of 2024-08-22

commit 04fab1dfd956a536fa3683682f3e8f2707f6f8ce
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-31 19:09:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-31 19:09:13 +0900

    merge revision(s) bb849ffdb18305f01457de4e9848c830eb83a2d7:

            Added explicitly begin-end block for Ruby 2.4.

              strscan, ipaddr and some default gems still support Ruby 2.4.

              After this, I extract this CoreAssertions to their repositories.

commit f095a085a43b609be6282fcc27ab7fe859259dfc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-31 18:51:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-31 18:51:41 +0900

    merge revision(s) 8a7e6f6852740e989ef8f679db5631306466a4ed:

            Improve base time of assert_linear_performance (#11369)

            Remove `.ceil` from base time calculation that makes 10x gap.
            This will make the assertion more strict and also less flaky.

commit f4847607ee52040fc62531f37001ea1a22acd856
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-31 18:49:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-31 18:49:58 +0900

    merge revision(s) f1c78b23313e63eb31a213cc7277b1eb206a581b:

            Suppress warning for shadowing outer local variable

commit b5bb0ee64b24251f103311e56168b96f5334cc6f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-31 18:49:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-31 18:49:27 +0900

    merge revision(s) d23964360335ad561f252cb6fe8e90df7ebee90e:

            core_assertions.rb: Support old rubies

            Some symbol argument might not be accepted by Process.clock_gettime.

commit bec6da392d26677194160cb4875f1bc491db27f5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-31 18:49:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-31 18:49:12 +0900

    merge revision(s) 533423ebe46ebfe3005198c12aa0d2c899c695ea:

            core_assertions.rb: Prefer CPU time clocks

            To prevent influence from other processes.

commit 7c2cdca7f250d0b270df585f69f275f72c415348
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-31 18:48:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-31 18:48:57 +0900

    merge revision(s) f9eb2515a3221cced611b4de971b72a78a7a566f:

            core_assertions.rb: Extract common code block

commit 07d7ffeb9c2c6537883a1ea7b180eb04ecbe47e6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-31 18:48:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-31 18:48:17 +0900

    merge revision(s) 3fe134759cc4904c74306e0832c22fa518a5bea2:

            Skip assert_linear_performance for RJIT

commit 00fada3890fe7bebbd660af3682eee6a8857b222
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-31 18:45:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-31 18:45:29 +0900

    merge revision(s) f07c756494b0e473ff8e4ece6f04c7ababe93b01:

            core_assertions.rb: Tweak timeout limit

            Increase the timeout limit when variance at rehearsal is small.

commit c96ba1fec4b4b80b60a08514bd9030258ba7f628
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-08-27 14:25:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-27 19:12:13 +0900

    Merge URI-0.12.3

commit 529b618235deb287be7c691064e11f942162f595
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-27 17:22:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-27 17:22:49 +0900

    Revert "merge revision(s) 29500e3034681a30045dea462d6bb653e8600738: [Backport #20698]"

    This reverts commit 3a3784a197383046537e66a9c567b96a52f0f86f.

commit 3a3784a197383046537e66a9c567b96a52f0f86f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-25 12:12:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-25 12:13:34 +0900

    merge revision(s) 29500e3034681a30045dea462d6bb653e8600738: [Backport #20698]

            Update bundled gems list as of 2024-08-22

commit 21c708ee802e1a59901eccc6448e40e8f72189b8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-18 18:07:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-18 18:07:14 +0900

    merge revision(s) 992596fb7af18a7f472589a607d0eb3fbb03b49a: [Backport #20344]

            Fix next inside block argument stack underflow

            [Bug #20344]
            Fix compile_next adding removable adjust label

commit 65fed1c3e439bc47bcf6ec884431a86cb9ebd1dc
  Author:     Stan Hu <stanhu@gmail.com>
  AuthorDate: 2024-05-17 17:05:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-18 18:02:09 +0900

    Allow waitpid(-1, Process::WNOHANG) to be woken if a waitpid(pid) is

    ...pending

    If two threads are running, with one calling waitpid(-1, Process::WNOHANG),
    and another calling waitpid($some_pid), and then
    $some_other_pid exits, we would expect the waitpid(-1,
    Process::WNOHANG) call to retrieve that exit status. However, it
    cannot actually do so until $some_pid _also_ exits.

    This patch fixes the issue by calling do_waitpid unconditionally in
    waitpid_wait; this will ensure that a waitpid -1 actually reaps
    something (after first checking that no PID-directed call wants the
    process).

    [Bug #20490]

commit 50399eebd96c76ce808ea4d84fe39693f585a531
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-18 11:18:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-18 11:19:09 +0900

    merge revision(s) 1870505f478cc75993b296b7144a45137ace6937: [Backport #20651] [Backport #20571]

            Fix wrong unreachable chunk remove when jump destination label is unremovable

commit a8a25291447e3630d455e82851ca58fc8ac372ec
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-18 10:52:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-18 10:52:06 +0900

    merge revision(s) 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6: [Backport #20649]

            [Bug #20649] Allow `nil` as 2nd argument of `assign_error`

            Fallback to the last token element in that case, for the backward
            compatibilities.

commit 0f2f6b31aa6433fd800f0621b5bedbaf0da12a6f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-17 21:41:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-17 21:41:24 +0900

    merge revision(s) 2a7da0b6e76929c684cd948630a897c1d5b16c26: [Backport #20667]

            Update bundled gems list as of 2024-08-12

commit 6fd660e6179117a86304ef29ba0da71e5722be1a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-10 16:27:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-10 16:27:40 +0900

    merge revision(s) 657f4b99f61a15e21584b87f7b206933d116589b:

            Update bundled gems list as of 2024-08-02

commit c307c2b6a13bf11aef0c9ab8dea6e0ff77047c91
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-08-10 16:24:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-10 16:24:51 +0900

    merge revision(s) 54d26221b4c4cfc46048f30892c626db69ce9244:

            .travis.yml: Allow failures for ppc64le and s390x.

            Because Travis ppc64le/s390x are unstable.

            ppc64le:
            * https://app.travis-ci.com/github/ruby/ruby/builds/269211469
            * https://app.travis-ci.com/github/ruby/ruby/builds/269204073

            s390x:
            * https://app.travis-ci.com/github/ruby/ruby/builds/269201221

commit 634db38b22f0e6c3397a3780863e6e0650a68c9b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-08-08 16:44:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-08-08 18:00:44 +0900

    Added bootstrap job for release workflow

commit bbef31b7b4c715589392b215d4a40320221c9d2c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-08-07 10:47:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-08-07 12:07:01 +0900

    Fix installation failure of rss

commit 116d95b476aed8c7dd525d521bf35f5f324096c0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-08-01 13:31:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-06 18:59:52 +0900

    Revert "skip bundled gem rss test for a while."

    This reverts commit 0cc98ae353fd231bcd0e704c251198abc4406247.

commit 16f795b5e9321088c1ba765e0dfe4a8300fc18ad
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-08-01 13:31:23 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-06 18:59:52 +0900

    Reapply "merge revision(s) 9f708d48f6df37ee9600db9d51b57a156609a13b,0301473fb523c71d8cdc4966971f31f502001185,7f0e26b7f99bf76408569892ce20318501f74729: [Backport #20516]"

    This reverts commit 367ad5055c3d5210c884d4611e08ffa32ec608ee.

commit 06cfabd49a1be9c00f2cb7d477cde6d47c3b8d32
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-02-16 17:57:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-06 18:59:52 +0900

    Adjust indent

commit 84f2da297f325b1fcde887bc307a4719cd5d9dab
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-02-16 16:33:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-06 18:59:52 +0900

    Try to find gemspec from `.bundle/specifications

commit 6517f15f9f07d1a516532fb08c264c1a113e9993
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-02-16 15:39:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-06 18:59:52 +0900

    Try to load original gemspec from `.bundle/gems/foo-x.y.z/foo.gemspec`.

    `.bundle/specification/foo-x.y.z.gemspec` may be changed our toolchain

commit 2e7949f006e4ab092b3749b89130e6888b6fdf48
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-02-16 17:23:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-06 18:59:52 +0900

    Use gemspec that keeps original dependencies

commit b62e1df3a1527c811f7fe857423023a479bc807f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-08-01 13:19:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-06 18:59:52 +0900

    Revert "Backport [Bug #19158] for Ruby 3.2 (#7356)"

    This reverts commit 65ab2c1ef23bd4a02120a27c371dce12ea9024d4.

commit 7fc6448ec7f7505ca5772af0a60ee780c321492c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-07-27 00:10:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-02 18:26:26 +0900

    Fix ceil when ndigits is large

    [Bug #20654]

    This commit fixes Integer#ceil and Float#ceil when the number is
    negative and ndigits is large such that 10**ndigits is a bignum.

    Previously, it would return 0 in such cases. However, this would cause
    unexpected behaviour such as:

        puts 1.ceil(-5) # => 100000
        puts 1.ceil(-10) # => 10000000000
        puts 1.ceil(-20) # => 0

    This commit changes the last result so that it will return
    100000000000000000000.

commit 7048fbdf59509e4f52eff56d7c044ed28eb67727
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-07-27 00:10:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-08-02 18:26:26 +0900

    Fix floor when ndigits is large

    [Bug #20654]

    This commit fixes Integer#floor and Float#floor when the number is
    negative and ndigits is large such that 10**ndigits is a bignum.

    Previously, it would return 0 in such cases. However, this would cause
    unexpected behaviour such as:

        puts -1.floor(-5) # => -100000
        puts -1.floor(-10) # => -10000000000
        puts -1.floor(-20) # => 0

    This commit changes the last result so that it will return
    -100000000000000000000.

commit 0cc98ae353fd231bcd0e704c251198abc4406247
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-26 22:37:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-26 22:37:30 +0900

    skip bundled gem rss test for a while.

commit 31d0f1a2e7dbfb60731d1f05b868e1d578cda493
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-26 20:54:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-26 20:54:27 +0900

    bump patchlevel.

commit 367ad5055c3d5210c884d4611e08ffa32ec608ee
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-26 20:53:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-26 20:53:32 +0900

    Revert "merge revision(s) 9f708d48f6df37ee9600db9d51b57a156609a13b,0301473fb523c71d8cdc4966971f31f502001185,7f0e26b7f99bf76408569892ce20318501f74729: [Backport #20516]"

    This reverts commit 56c311aa0b20dee13ab43309ae3386f57f8cb797.

commit ae9a43512c6a6c8d4c60a0987137bc0a00a97d85
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-26 18:41:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-26 18:41:18 +0900

    bump teeny

commit 1dba48bb3a92bccc350508935ed0b59a249b674b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-22 11:36:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-22 12:21:12 +0900

    bump rexml version to 3.3.2.

commit 483ad38c6968feb1990f36d48d14fd55988d2150
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-21 12:25:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-21 12:25:04 +0900

    merge revision(s) b15e88e0fcccb03b9cc5e4c1478ec9b10e26c961: [Backport #19619]

            [Bug #19619] Preserve numbered parameters context

            Preserve numbered parameters context across method definitions

commit 2ac8e2049bad37da38576b1ed263713c66eba2c9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-20 15:12:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-20 15:12:36 +0900

    merge revision(s) e1104017e3080fd432c0b5fdc3ae6e004ffd0834: [Backport #19781]

            YJIT: Fix cfp inconsistency on tailcall (#8107)

            [Bug #19781]

commit 4f1e047f86b159528055d37ee0da2ad6e5a38c23
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-20 13:11:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-20 13:11:29 +0900

    merge revision(s) a3eb5e5c70eaee12964cdd807b8f19950003141f: [Backport #20573]

            Don't call `Warning.warn` unless the category is enabled (#10981)

            Don't call `Warning.warn` unless the category is enabled

            The warning category should be enabled if we want to call
            `Warning.warn`.

            This commit speeds up the following benchmark:

            ```ruby
            eval "def test; " +
              1000.times.map { "'  '.chomp!" }.join(";") + "; end"

            def run_benchmark count
              i = 0
              while i < count
                start = Process.clock_gettime(Process::CLOCK_MONOTONIC)
                yield
                ms = Process.clock_gettime(Process::CLOCK_MONOTONIC) - start
                puts "itr ##{i}: #{(ms * 1000).to_i}ms"
                i += 1
              end
            end

            run_benchmark(25) do
              250.times do
                test
              end
            end
            ```

            On `master` this runs at about 92ms per iteration. With this patch, it
            is 7ms per iteration.

            [Bug #20573]

commit 3fe51aa26867159af574fac8eba7ae86a0b30971
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-20 13:00:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-20 13:05:33 +0900

    merge revision(s) fba8aff7af450e476e97b62385427dfa51850955, d8c6e91748871ab2287d7703347847fe18a292d2: [Backport #20592]

            [Bug #20592] Fix segfault when sending NULL to freeaddrinfo

            On alpine freeaddrinfo does not accept NULL pointer

            Fix dangling `else`

commit c10c73fd16f1b7c9b658afee2b1b53ecfaed4fa4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-20 12:53:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-20 12:53:25 +0900

    merge revision(s) 2dd46bb82ffc4dff01d7ea70922f0e407acafb4e: [Backport #20468]

            [Bug #20468] Fix safe navigation in `for` variable

commit db5201ffd531d07747de03c55c4cb1c0e9e5c5bf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 22:09:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 22:09:30 +0900

    Revert "merge revision(s) 5fa6ba9568e87e43e08a4daeba1572254c589fb1: [Backport #20500]"

    This reverts commit fc5b9ffad1b0710bd999521d0bf9631af6b762c2.

commit 96a82418b2efe98a92f239a9a1cbf30dd396d335
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 22:01:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 22:01:57 +0900

    merge revision(s) 05553cf22d43dd78b8f30cc4591230b5c000c538: [Backport #20517]

            [Bug #20517] Make a multibyte character one token at meta escape

commit a804d5514c7c0608b9fb52426ec3ec738420ad29
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 21:51:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 21:51:03 +0900

    merge revision(s) d503e1b95a40e45d7767e0175de60092de4ba54e: [Backport #20030]

            [Bug #20030] dispatch invalid escaped character without ignoring it

commit fc5b9ffad1b0710bd999521d0bf9631af6b762c2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 21:31:23 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 21:31:23 +0900

    merge revision(s) 5fa6ba9568e87e43e08a4daeba1572254c589fb1: [Backport #20500]

            [Bug #20500] Search non-default directories for jemalloc

            Co-Authored-by: lish82 (Hiroki Katagiri)

commit 958adb5b65f1edd0d4a204d299baf05f0b490c2c
  Author:     kimuraw (Wataru Kimura) <kimuraw@i.nifty.jp>
  AuthorDate: 2024-07-14 10:36:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 20:44:07 +0900

    [Bug #20633] Fix the condition for `atomic_signal_fence`

    `AC_CHECK_DECLS` defines `HAVE_DECL_SYMBOL` to 1 if declared, 0
    otherwise, not undefined.

commit c22398f96c29c2357bee50b291c358cc34837013
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 18:03:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 18:03:08 +0900

    merge partially d292a9b98ce03c76dbe13138d20b9fbf613cc02d. Just add the test to ensure the issue doesn't exit in ruby_3_2 branch.

commit b72deb7ca1198f8c799cd5e7e44635cf50abd7ec
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 17:56:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 17:56:01 +0900

    merge revision(s) 58918788abd63901588e4aa1e39b5c057321c10a: [Backport #20342]

            [Bug #20342] Consider wrapped load in `main` methods

commit bfdb6d5a9dca32b41a2b22c108b46f9fc01fee35
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 16:47:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 16:47:41 +0900

    update GitHub Action spec_guards workflow.

commit 8200325e932e40e1ae7a959e588dae655bea9660
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 14:03:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 14:03:11 +0900

    follow-up for a6b7aad954680e23e7db81d69a7e8e44583bf8b4. suppress compiler warning.

commit a6b7aad954680e23e7db81d69a7e8e44583bf8b4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 13:40:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 13:40:01 +0900

    merge revision(s) 7e4b1f8e1935a10df3c41ee60ca0987d73281126: [Backport #20322]

            [Bug #20322] Fix rb_enc_interned_str_cstr null encoding

            The documentation for `rb_enc_interned_str_cstr` notes that `enc` can be
            a null pointer, but this currently causes a segmentation fault when
            trying to autoload the encoding. This commit fixes the issue by checking
            for NULL before calling `rb_enc_autoload`.

commit 519d164b6682a8b9fde2b1d5ab7d74f54c4f0224
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 13:24:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 13:24:57 +0900

    merge revision(s) c7ce2f537f96ab2cf2f5fc2982d6147866ff5340: [Backport #20304]

            Fix memory leak in setting encodings

            There is a memory leak in Encoding.default_external= and
            Encoding.default_internal= because the duplicated name is not freed
            when overwriting.

                10.times do
                  1_000_000.times do
                    Encoding.default_internal = nil
                  end

                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                 25664
                 41504
                 57360
                 73232
                 89168
                105056
                120944
                136816
                152720
                168576

            After:

                9648
                9648
                9648
                9680
                9680
                9680
                9680
                9680
                9680
                9680

commit db45554fef4c8e1b0ba494965449db13068e6051
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 12:00:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 12:00:14 +0900

    merge revision(s) 1faeb44dfcf777ace28321e80d0ebf942161a0a7, 7f87ad9fc4bc45faf8cd33602a025f27c094b2fd: [Backport #20431]

            Check if macros are defined before using

            Assume macros with the same prefix would be defined together.

            Refer autoconfigured endian macro (#10572)

            Remove the case `RB_IO_BUFFER_HOST_ENDIAN` is not defined.

commit 0cb1e753cadb4cd1706ecf334e007bb246438577
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 11:55:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 11:55:41 +0900

    Revert "merge revision(s) 5e0c17145131e073814c7e5b15227d0b4e73cabe: [Backport #20169]"

    This reverts commit 6b73406833dd22e489114fa77c1c80c4b7af2ed0.

commit b5e554d03a0bd34f260e783e84f4d8a16de39a61
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 11:08:50 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 11:08:50 +0900

    Revert "merge revision(s) e04146129ec6898dd6a9739dad2983c6e9b68056, d5080f6e8b77364483ff6727b1065e45e180f05d: [Backport #20292]"

    This reverts commit a54c717c7a74b91a3cdf20742c355e3ea42052d1.

commit 8051a6d3854687c008d69d3d198a16d0d1c5dac1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 11:07:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 11:07:31 +0900

    Revert "follow-up for a54c717c7a74b91a3cdf20742c355e3ea42052d1."

    This reverts commit 715633ba6e982dc5404abeafc5246c31af92ac10.

commit 715633ba6e982dc5404abeafc5246c31af92ac10
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 10:41:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 10:41:21 +0900

    follow-up for a54c717c7a74b91a3cdf20742c355e3ea42052d1.

commit 90f4c5dc73af3fff76500dd4223792a6d9f58636
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 09:50:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 09:50:14 +0900

    merge revision(s) dc146babf47a84bbd1f176d766637d4a40327019, f23d5028059078a346efc977287b669d494a5a3f, a0f7de814ae5c299d6ce99bed5fb308a05d50ba0: [Backport #20296]

            [Bug #20296] Clear errinfo when `exception: false`

            [Bug #20296] Refine the test

            [Bug #20296] Fix the default assertion message

commit a54c717c7a74b91a3cdf20742c355e3ea42052d1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 09:26:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 09:26:25 +0900

    merge revision(s) e04146129ec6898dd6a9739dad2983c6e9b68056, d5080f6e8b77364483ff6727b1065e45e180f05d: [Backport #20292]

            [Bug #20292] Truncate embedded string to new capacity

            Fix -Wsign-compare on String#initialize
            MIME-Version: 1.0
            Content-Type: text/plain; charset=UTF-8
            Content-Transfer-Encoding: 8bit

            ../string.c:1886:57: warning: comparison of integer expressions of different signedness: ‘size_t’ {aka ‘long unsigned int’} and ‘long int’ [-Wsign-compare]
             1886 |                 if (STR_EMBED_P(str)) RUBY_ASSERT(osize <= str_embed_capa(str));
                  |                                                         ^~

commit 6b73406833dd22e489114fa77c1c80c4b7af2ed0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-15 08:46:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-15 08:50:38 +0900

    merge revision(s) 5e0c17145131e073814c7e5b15227d0b4e73cabe: [Backport #20169]

            Make io_fwrite safe for compaction

            [Bug #20169]

            Embedded strings are not safe for system calls without the GVL because
            compaction can cause pages to be locked causing the operation to fail
            with EFAULT. This commit changes io_fwrite to use rb_str_tmp_frozen_no_embed_acquire,
            which guarantees that the return string is not embedded.

commit 9f1e18a138e5196c04c5231c6a799dc637f2e9af
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-13 18:48:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-13 18:48:18 +0900

    follow-up for 3faef1d40dc1d6eea8ffcd624528f431ccaf0a5b.

commit 90a44bcd39c569d851f73d167955c83f3ff2384f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-13 15:43:23 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-13 15:43:23 +0900

    merge revision(s) f36a71e26995b69ff72bc132bbcf40ad89571414: [Backport #20307]

            [Bug #20307] Fix `Hash#update` to make frozen copy of string keys

commit d802b6122b5e501cc0172376acb185160710454a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-02-27 01:22:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-13 15:42:41 +0900

    Extract `RHASH_STRING_KEY_P`

commit 3faef1d40dc1d6eea8ffcd624528f431ccaf0a5b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-02-26 23:47:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-13 15:40:01 +0900

    Extract `RHASH_IDENTHASH_P`

commit 584a02aaafda74c21d24dc4c5e223a2482c7fde3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-13 15:17:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-13 15:17:51 +0900

    merge revision(s) d19d683a354530a27b4cbb049223f8dc70c75849: [Backport #20250]

            rb_obj_setup: do not copy RUBY_FL_SEEN_OBJ_ID

            [Bug #20250]

            We're seting up a new instance, so it never had an associated
            object_id.

commit c97a632363a170879b9755c5a123e92533908039
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-07 14:42:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-07 16:46:02 +0900

    merge revision(s) 82b57d7bfeefd717c10f7a5a3484aca6b3e708a3: [Backport #20162]

            Fix memory leak when duplicating too complex object

            [Bug #20162]

            Creating a ST table then calling st_replace leaks memory because the
            st_replace overwrites the ST table without freeing any of the existing
            memory. This commit changes it to use st_copy instead.

            For example:

                RubyVM::Shape.exhaust_shapes

                o = Object.new
                o.instance_variable_set(:@a, 0)

                10.times do
                  100_000.times { o.dup }

                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                23264
                33600
                42672
                52160
                61600
                71728
                81056
                90528
                100560
                109840

            After:

                14752
                14816
                15584
                15584
                15664
                15664
                15664
                15664
                15664
                15664

commit bd5df1693c89d389471d145fc19b487c708912b1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-07 14:47:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-07 16:44:06 +0900

    merge revision(s) e626da82eae3d437b84d4f9ead0164d436b08e1a, f3af5ae7e6c1c096bbfe46d69de825a02b1696cf: [Backport #20311]

            Don't pin named structs defined in Ruby

            [Bug #20311]

            `rb_define_class_under` assumes it's called from C and that the
            reference might be held in a C global variable, so it adds the
            class to the VM root.

            In the case of `Struct.new('Name')` it's wasteful and make
            the struct immortal.

            Make Struct memory leak test faster

            [Bug #20311]

            It times out on some platform, so we can reduce iterations.
            On my machine it completes in 250ms and RSS grows 8X.

commit 2a4469ea590e6719eb30e8b7aea7e147e3b82f75
  Author:     Ivo Anjo <ivo.anjo@datadoghq.com>
  AuthorDate: 2024-06-21 19:48:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-06 16:20:45 +0900

    [Backport #11036 to 3.2] Add explicit compiler fence when pushing frames to ensure safe profiling

    **What does this PR do?**

    This PR tweaks the `vm_push_frame` function to add an explicit compiler
    fence (`atomic_signal_fence`) to ensure profilers that use signals
    to interrupt applications (stackprof, vernier, pf2, Datadog profiler)
    can safely sample from the signal handler.

    This is a backport of #11036 to Ruby 3.2 .

    **Motivation:**

    The `vm_push_frame` was specifically tweaked in
    https://github.com/ruby/ruby/pull/3296 to initialize the a frame
    before updating the `cfp` pointer.

    But since there's nothing stopping the compiler from reordering
    the initialization of a frame (`*cfp =`) with the update of the cfp
    pointer (`ec->cfp = cfp`) we've been hesitant to rely on this on
    the Datadog profiler.

    In practice, after some experimentation + talking to folks, this
    reordering does not seem to happen.

    But since modern compilers have a way for us to exactly tell them
    not to do the reordering (`atomic_signal_fence`), this seems even
    better.

    I've actually extracted `vm_push_frame` into the "Compiler Explorer"
    website, which you can use to see the assembly output of this function
    across many compilers and architectures: https://godbolt.org/z/3oxd1446K

    On that link you can observe two things across many compilers:
    1. The compilers are not reordering the writes
    2. The barrier does not change the generated assembly output
       (== has no cost in practice)

    **Additional Notes:**

    The checks added in `configure.ac` define two new macros:
    * `HAVE_STDATOMIC_H`
    * `HAVE_DECL_ATOMIC_SIGNAL_FENCE`

    Since Ruby generates an arch-specific `config.h` header with
    these macros upon installation, this can be used by profilers
    and other libraries to test if Ruby was compiled with the fence enabled.

    **How to test the change?**

    As I mentioned above, you can check https://godbolt.org/z/3oxd1446K
    to confirm the compiled output of `vm_push_frame` does not change
    in most compilers (at least all that I've checked on that site).

commit 2b35d80834f14011f7d313f8fac7855dc9949f70
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-06 15:55:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-06 15:55:04 +0900

    merge revision(s) 75aaeb35b82da26359b9418d2963384d0c55839c: [Backport #20239]

            [Bug #20239] Fix overflow at down-casting

commit a67b43d99e24dc7c2a9e134a65f28f968fe124c1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-06 15:54:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-06 15:54:03 +0900

    merge revision(s) 3a04ea2d0379dd8c6623c2d5563e6b4e23986fae: [Backport #20305]

            [Bug #20305] Fix matching against an incomplete character

            When matching against an incomplete character, some `enclen` calls are
            expected not to exceed the limit, and some are expected to return the
            required length and then the results are checked if it exceeds.

commit 89de66dbb0d8454c9d69faa331d6e35f8b315cce
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-06 13:33:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-06 13:35:22 +0900

    merge revision(s) 78d9fe69479d32214a52ad7291c3973f1b6b7f6f, 04729fe68dceddab045be7324e26c2bb15aa62c7: [Backport #20286] [Backport #20286]

            Ensure that exiting thread invokes end-of-life behaviour. (#10039)

            Fix exception handling in `rb_fiber_scheduler_set`. (#10042)

commit 5577e5d396cc8f062833b67d6280db6cc8501e7a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-06 13:26:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-06 13:26:26 +0900

    merge revision(s) a7ff264477105b5dc0ade6facad4176a1b73df0b: [Backport #20393]

            Don't clear pending interrupts in the parent process. (#10365)

commit 2f8f17e842666abb05ca522d6072c957fab0e12e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-06 11:16:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-06 11:16:44 +0900

    merge revision(s) 5d1702e01a36e11b183fe29ce10780a9b1a41cf0: [Backport #20414]

            Enumerator should use a non-blocking fiber, change `rb_fiber_new` to be non-blocking by default. (#10481)

commit 5141d72fde2528721663ddbc0554ac81ddc0656f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-07-06 11:01:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-06 11:01:02 +0900

    merge revision(s) 1e08a9f0e9058186db18f29efc6458c00f10a856: [Backport #20499]

            [Bug #20499] Use Xcode owned tools for Xcode clang

            Xcode has its own version tools that may be incompatible with genuine
            LLVM tools, use the tools in the same directory.

commit 2dfaa00e09ceb7f1dcee87acd56c47701fc8ca19
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-07-05 17:47:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-07-05 18:37:44 +0900

    Added macos-13 and removed macos-11

commit eca044a3870d4767d10c0ca8a51f1de4e5e2fdb0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-19 06:13:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-19 06:13:54 +0900

    bump patchlevel.

commit 8e68752a5e48c5baf07114952d256efa360e3f4b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-19 00:27:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-19 00:27:18 +0900

    bump rexml version to 3.2.9.

commit fa042a0f10f70347c1717c068d96e43e19f2171b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-01-22 10:36:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-18 22:53:59 +0900

    added redirect wrapper for envutil

commit 963bb96e29204f351fa58a205a6eec075c0194ff
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-01-17 12:31:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-18 22:53:58 +0900

    Load Rake::TaskLib when missing it

commit 5a70a323904368987b79c59140bd2aca009da7a0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-06-14 01:33:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-18 22:53:58 +0900

    Show prerequisites for compile task

commit 9542ef2798c6f555df5115da6881a5d50ed7034b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-06-14 01:21:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-18 22:53:58 +0900

    Allow test-unit-ruby-core files to be loaded from bundled gems

    Separate the directly from the customized test-unit, since it may not
    work with bundled gems.

commit 56c311aa0b20dee13ab43309ae3386f57f8cb797
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-02 07:13:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-18 22:50:39 +0900

    merge revision(s) 9f708d48f6df37ee9600db9d51b57a156609a13b,0301473fb523c71d8cdc4966971f31f502001185,7f0e26b7f99bf76408569892ce20318501f74729: [Backport #20516]

            Clear runtime dependencies if default gems is specified.

            The current build system uses runtime dependencies from only
            `.bundle` directory. We shouldn't install runtime dependencies
            from rubygems.org when `make test-bundled-gems` is invoked.

            Fixed dependencies list format

            Re-use strscan with ruby repo

commit 8e7d5adb4a481e9b4050505ea88cdf64278cacb7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-01 16:11:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-18 22:50:16 +0900

    partially merge revision(s) 70ad58cb62b195ba86a5ef07a565b22b02a040ea: [Backport #20516]

            Update bundled_gems

commit e308f47888cfb5c85344d030098932340b57147d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-18 22:47:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-18 22:47:12 +0900

    Revert "merge revision(s) 18eaf0be905e3e251423b42d6f4e56b7cae1bc3b: [Backport #20494]"

    This reverts commit ec30266267b2a063089b8ce7967203bcbadbdf4e.

commit 478b21f63127f30fd1a9ee051a6c5593f41937ed
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-18 22:46:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-18 22:46:48 +0900

    Revert "merge revision(s) 22e4eeda6561693367fc7a00b92b90f46b09cabd, 1ab7c412d2e3880a7ad233c32e93961888f8145c, fd549b229b0822198ddc847703194263a2186ed1: [Backport #20515]"

    This reverts commit dc4ca25e0a01e072ba3cf1fc47612aff72c980af.

commit dc4ca25e0a01e072ba3cf1fc47612aff72c980af
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-15 13:13:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-15 13:13:19 +0900

    merge revision(s) 22e4eeda6561693367fc7a00b92b90f46b09cabd, 1ab7c412d2e3880a7ad233c32e93961888f8145c, fd549b229b0822198ddc847703194263a2186ed1: [Backport #20515]

            ci: Test whether GMP is working in compilers.yml (#10875)

            Avoid reoccurence of [Bug #20515]

            Requires https://github.com/ruby/ruby/pull/10876 since 18eaf0be905e3e251423b42d6f4e56b7cae1bc3b

            bug: https://bugs.ruby-lang.org/issues/20515

            RUBY_CHECK_HEADER didn't define HAVE_{header-file} (#10876)

            --with-gmp is not working at all because HAVE_GMP_H
            was missing since 18eaf0be90. [Bug #20515]

            bug: https://bugs.ruby-lang.org/issues/20515
            follow-up: https://bugs.ruby-lang.org/issues/20494
            follow-up: 18eaf0be905e3e251423b42d6f4e56b7cae1bc3b
            follow-up: https://github.com/ruby/ruby/pull/10805

            test_bignum: defined? returns String (#10880)
            MIME-Version: 1.0
            Content-Type: text/plain; charset=UTF-8
            Content-Transfer-Encoding: 8bit

            didn't verify the test is working properly due to mistaken auto-merge… [Bug #20515]

            bug: https://bugs.ruby-lang.org/issues/20515
            follow-up: 22e4eeda6561693367fc7a00b92b90f46b09cabd
            follow-up: https://github.com/ruby/ruby/pull/10875

commit ec30266267b2a063089b8ce7967203bcbadbdf4e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-15 13:09:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-15 13:09:47 +0900

    merge revision(s) 18eaf0be905e3e251423b42d6f4e56b7cae1bc3b: [Backport #20494]

            [Bug #20494] Search non-default directories for GMP

            Co-Authored-by: lish82 (Hiroki Katagiri)

commit 2f010f31f1887ad0f429709a2906fc5a4dae8e87
  Author:     KJ Tsanaktsidis <ktsanaktsidis@zendesk.com>
  AuthorDate: 2024-05-18 18:37:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-15 13:05:25 +0900

    Inline RB_VM_SAVE_MACHINE_CONTEXT into BLOCKING_REGION

    There's an exhaustive explanation of this in the linked redmine bug, but
    the short version is as follows:

    blocking_region_begin can spill callee-saved registers to the stack for
    its own use. That means they're not saved to ec->machine by the call to
    setjmp, since by that point they're already on the stack and new,
    different values are in the real registers. ec->machine's end-of-stack
    pointer is also bumped to accomodate this, BUT, after
    blocking_region_begin returns, that points past the end of the stack!

    As far as C is concerned, that's fine; the callee-saved registers are
    restored when blocking_region_begin returns. But, if another thread
    triggers GC, it is relying on finding references to Ruby objects by
    walking the stack region pointed to by ec->machine.

    If the C code in exec; subsequently does things that use that stack
    memory, then the value will be overwritten and the GC might prematurely
    collect something it shouldn't.

    [Bug #20493]

commit b494ecfbc1b2a934d27233b7171c40adaa81e3c5
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-06-11 08:05:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-15 13:02:26 +0900

    Fix inconsistent evaluation of keyword splat (#10959)

    [Bug #20180]

    Backports #9624.

commit e0e1a0f502fe57e7e7e8cf643b8f141b4582d62d
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2024-06-10 22:12:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-15 12:58:19 +0900

    compile.c: use putspecialobject for RubyVM::FrozenCore

    [Bug #20569]

    `putobject RubyVM::FrozenCore`, is not serializable, we
    have to use `putspecialobject VM_SPECIAL_OBJECT_VMCORE`.

commit ab7dfa7ff270feb155d4715fb7ffcee3668ef38f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-03 20:59:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-03 20:59:51 +0900

    merge revision(s) 631449ac6b9336dfce577a786aff7eca0b8abcf1:

            README.ja.md: Remove Cirrus CI badge image. folloup for 15ee9c7c1b693f29b6b2dbe7b47488bf154e481c.

commit f9a9035b98526b8b50587ab7959cc1d2292f5b7f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-03 19:57:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-03 19:57:28 +0900

    merge revision(s) 15ee9c7c1b693f29b6b2dbe7b47488bf154e481c:

            [DOC] README.md: Remove Cirrus CI badge image. (#8785)

            We removed the `.cirrus.yml` at the commit
            <01b5d1d2ff6ca91b2909dfa67295f59b53e6f065>.
            Let's remove the badge image too.

commit 5afdfbdd0924c2cede5626e9d762caa90ce656d9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-03 19:57:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-03 19:57:19 +0900

    merge revision(s) 01b5d1d2ff6ca91b2909dfa67295f59b53e6f065:

            YJIT: Add a cargo job for Arm64 and remove .cirrus.yml (#8679)

            * YJIT: Add a cargo job for Arm64

            * YJIT: Use command names as job names

            They look more consistent with jobs that use the command name as a job
            name, such as `make (check)`, `make (test-bundled-gems)`, etc.

            * Remove .cirrus.yml

commit 3c04fd11a0a387d99d0e439b0e4147128beaa88d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-03 12:22:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-03 12:22:51 +0900

    Revert "partially merge revision(s) 70ad58cb62b195ba86a5ef07a565b22b02a040ea: [Backport #20516]"

    This reverts commit 519ac9c5fd7bfa75655231188ac1da9589563618.

commit c48b2312acf40371590ac2a9618f4cb39472ef0f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-03 12:22:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-03 12:22:25 +0900

    Revert "merge revision(s) 9f708d48f6df37ee9600db9d51b57a156609a13b,0301473fb523c71d8cdc4966971f31f502001185,7f0e26b7f99bf76408569892ce20318501f74729: [Backport #20516]"

    This reverts commit 0de1ff12973ffc04bc9a8b0799e963922986d1eb.

commit 0de1ff12973ffc04bc9a8b0799e963922986d1eb
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-02 07:13:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-02 07:13:25 +0900

    merge revision(s) 9f708d48f6df37ee9600db9d51b57a156609a13b,0301473fb523c71d8cdc4966971f31f502001185,7f0e26b7f99bf76408569892ce20318501f74729: [Backport #20516]

            Clear runtime dependencies if default gems is specified.

            The current build system uses runtime dependencies from only
            `.bundle` directory. We shouldn't install runtime dependencies
            from rubygems.org when `make test-bundled-gems` is invoked.

            Fixed dependencies list format

            Re-use strscan with ruby repo

commit 519ac9c5fd7bfa75655231188ac1da9589563618
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-06-01 16:11:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-06-01 16:11:08 +0900

    partially merge revision(s) 70ad58cb62b195ba86a5ef07a565b22b02a040ea: [Backport #20516]

            Update bundled_gems

commit dd77934ca6e2e8b2b894f2460017323b33b619b6
  Author:     matoro <matoro@users.noreply.github.com>
  AuthorDate: 2024-05-24 05:10:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-28 09:26:37 +0900

    [ruby/readline-ext] Skip test_interrupt_in_other_thread on arm32-linux

    This is a combination of main Ruby commit
    https://github.com/ruby/ruby/commit/aefc98891c42024039f19ef45bdfe93fbc590b7c
    and my PR correcting the regex https://github.com/ruby/ruby/pull/10819.
    Upstream Ruby requests that changes to this test go to readline-ext repo
    before being backported to 3.2 branch.

    https://github.com/ruby/readline-ext/commit/868f873a78

commit 0e664ebcd36879591223d1ecbb181aa05d82a4d9
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2023-09-14 17:37:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-05-18 20:09:56 +0900

    Fix `io_buffer_get_string` default length computation. (#8427)

    * Fix `io_buffer_get_string` default length computation.

    When an offset bigger than the size is given, the resulting length will be
    computed incorrectly. Raise an argument error in this case.

    * Validate all arguments.

commit 67d499a7646a4f2f5294b6c83ac9503fcd873270
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2023-05-24 10:17:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-05-18 20:09:56 +0900

    Improvements to `IO::Buffer` `read`/`write`/`pread`/`pwrite`. (#7826)

    - Fix IO::Buffer `read`/`write` to use a minimum length.

commit 359e40e3c9986b8a5d77359995f0e926d1c6eb72
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2023-05-22 12:27:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-05-18 20:09:56 +0900

    Rename `data` -> `buffer` for better readability. (#7836)

commit 2d686e1019414f6bbb7ccbfa897b7b665250743d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-05-16 11:36:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-05-16 11:36:47 +0900

    merge revision(s) ae8990aef098410ecc2b5f48fea9d7d171a3c5f6: [Backport #20183]

            Alias init functions

            The extension library has each initialization function named "Init_" +
            basename. If multiple extensions have the same base name (such as
            cgi/escape and erb/escape), the same function will be registered for
            both names.

            To fix this conflict, rename the initialization functions under sub
            directories using using parent names, when statically linking.

commit 449899b38314d0ecbe61e42d34398bdf2561b8e9
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2024-05-09 18:56:51 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2024-05-14 16:29:21 +0900

    Fix `String#index` to clear MatchData when a regexp is passed

    [Bug #20421]

    The bug was fixed in Ruby 3.3 via 9dcdffb8bf8a3654fd78bf1a58b30c8e13888a7a

commit a10a0d0c77826b97ec246274adcc80952049688b
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2023-01-17 05:30:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-08 20:12:13 +0900

    CI: Pass -O2 for annocheck

    Because `optflags` is pasted into the invocation line after `CC`, we were
    building with -O1 unintentionally. You can see this in the configuration
    summary: https://github.com/ruby/ruby/actions/runs/3933391169/jobs/6727044423#step:9:753

    The check actually fails with -O2. To make it pass, upstream suggest
    that we use the annocheck GCC plugin. Since it requires building from
    source as the debian package for it isn't ready yet, punt on it for now
    and use `--skip-gaps`.

    Co-authored-by: Jun Aruga <jaruga@redhat.com>

commit 8029ee41768cdc6b86cad90390f281185ab995e2
  Author:     Jun Aruga <jaruga@redhat.com>
  AuthorDate: 2024-03-12 22:39:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-08 20:12:13 +0900

    [ruby/openssl] test_asn1.rb: Remove the assertions of the time string format without second.

    This commit fixes the following errors in the tests.
    Because the OpenSSL project changed the code to make the time string format
    without second invalid. So, we drop the assertions.

    ```
    1) Error: test_generalizedtime(OpenSSL::TestASN1): OpenSSL::ASN1::ASN1Error: generalizedtime is too short
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode_test'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:433:in `test_generalizedtime'
         430:       OpenSSL::ASN1::GeneralizedTime.new(Time.utc(9999, 9, 8, 23, 43, 39))
         431:     # LibreSSL 3.6.0 requires the seconds element
         432:     return if libressl?
      => 433:     decode_test B(%w{ 18 0D }) + "201612081934Z".b,
         434:       OpenSSL::ASN1::GeneralizedTime.new(Time.utc(2016, 12, 8, 19, 34, 0))
         435:     # not implemented
         436:     # decode_test B(%w{ 18 13 }) + "https://github.com/ruby/openssl/commit/201612081934+0930".b,

    2) Error: test_utctime(OpenSSL::TestASN1): OpenSSL::ASN1::ASN1Error: utctime is too short
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode_test'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:411:in `test_utctime'
         408:     end
         409:     # Seconds is omitted. LibreSSL 3.6.0 requires it
         410:     return if libressl?
      => 411:     decode_test B(%w{ 17 0B }) + "1609082343Z".b,
         412:       OpenSSL::ASN1::UTCTime.new(Time.utc(2016, 9, 8, 23, 43, 0))
         413:     # not implemented
         414:     # decode_test B(%w{ 17 11 }) + "https://github.com/ruby/openssl/commit/500908234339+0930".b,
    ```

    https://github.com/ruby/openssl/commit/2e826d5715

commit 0ca642cd300ee2d7a8f5dbef512344467285b2ea
  Author:     Xi Ruoyao <xry111@xry111.site>
  AuthorDate: 2024-04-24 14:42:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-05-08 20:12:13 +0900

    [ruby/net-http] Skip test_session_reuse_but_expire with OpenSSL 3.3

    OpenSSL 3.3.0 9 Apr 2024 is also broken.

    Signed-off-by: Xi Ruoyao <xry111@xry111.site>

    https://github.com/ruby/net-http/commit/ab525c956d

commit af471c0e0127eea0cafa6f308c0425bbfab0acf5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-04-23 19:20:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-04-23 19:20:09 +0900

    bump teeny

commit 90b194b5e3fe793c1ed895a4522675845181e6fd
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-04-23 19:18:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-04-23 19:18:14 +0900

    merge revision(s) 989a2355808a63fc45367785c82ffd46d18c900a:

            Fix Use-After-Free issue for Regexp

            Co-authored-by: Isaac Peka <7493006+isaac-peka@users.noreply.github.com>
            ---
             regexec.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 404f1e215a1707b31edba36f9f07a82367960618
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-04-23 19:17:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-04-23 19:17:53 +0900

    merge revision(s) 33e5b47c16f1fd3382186e6ffe73cfc6e00946f7:

            Fix handling of reg->dmin in Regex matching

            ---
             regexec.c | 10 ++++++++++
             1 file changed, 10 insertions(+)

commit 06049fe98ef6eced6ccf6028621f3e10edeedccb
  Author:     KJ Tsanaktsidis <ktsanaktsidis@zendesk.com>
  AuthorDate: 2024-03-28 13:57:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-04-08 18:40:47 +0900

    Backport https://github.com/ruby/ruby/pull/9240 to Ruby 3.2

    Merged into master in 7ba2506232d3fa6c4e82e3708c0ff746a1a8de5c

    [Bug #20050]

commit e6bf38a6e7fbae0097fdf51e3c752820a2c58ae4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-04-07 14:53:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-04-07 14:53:48 +0900

    merge revision(s) d3279a0c11ca45ca85027e7eb74dc4aac52c478b: [Backport #20327]

            [Bug #20327] Do not count subsecond to calculate UTC offset

            Assume that there will never be any time zones with UTC offsets that
            are subseconds.  Historically, UTC offset has only been used down to
            the second.
            ---
             test/ruby/test_time_tz.rb | 8 ++++++++
             time.c                    | 2 +-
             2 files changed, 9 insertions(+), 1 deletion(-)

commit baa5bc16c17e3b4dac7b590ed5d6b7e705535e15
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-04-07 14:41:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-04-07 14:41:29 +0900

    merge revision(s) adaff1fc496b6f01fb1c4c812b9b4082618e2f79: [Backport #19592]

            [Bug #19592] Fix ext/Setup support

            After [1], using ext/Setup to link some, but not all extensions failed
            during linking. I did not know about this option, and had assumed that
            only `--with-static-linked-ext` builds can include statically linked
            extensions.

            Include the support code for statically linked extensions in all
            configurations like before [1]. Initialize the table lazily to minimize
            footprint on builds that have no statically linked extensions.

            [1]: 790cf4b6d0475614afb127b416e87cfa39044d67 "Fix autoload status of
                     statically linked extensions"
            ---
             load.c    | 28 +++++++++++++++++-----------
             vm.c      |  3 ---
             vm_core.h |  6 ------
             3 files changed, 17 insertions(+), 20 deletions(-)

commit 27606daf8efeb0ae6d0590a2c9bb1c5aae07f140
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-03-31 17:37:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-03-31 17:37:01 +0900

    merge revision(s) ac0163949a6ee678dfccec9f6e56422b91e5f0a9,01fd262e62076277a41af72ea13f20deb1b462a2: [Backport #20245]

            Compile code without Symbol GC always

            ---
             symbol.c | 28 +++++++++++++---------------
             1 file changed, 13 insertions(+), 15 deletions(-)

            Fix crash when checking symbol encoding

            [Bug #20245]

            We sometimes pass in a fake string to sym_check_asciionly. This can crash
            if sym_check_asciionly raises because it creates a CFP with the fake
            string as the receiver which will crash if GC tries to mark the CFP.

            For example, the following script crashes:

                GC.stress = true
                Object.const_defined?("\xC3")
            ---
             symbol.c                 | 17 ++++++++++-------
             test/ruby/test_module.rb |  8 ++++++++
             2 files changed, 18 insertions(+), 7 deletions(-)

commit 4f3ed07d5bfd581b630e4afc8b9bb170ce781e7f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-03-31 17:18:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-03-31 17:18:55 +0900

    merge revision(s) ade56737e2273847426214035c0ff2340b43799a: [Backport #20190]

            Fix coderange of invalid_encoding_string.<<(ord)

            Appending valid encoding character can change coderange from invalid to valid.
            Example: "\x95".force_encoding('sjis')<<0x5C will be a valid string "\x{955C}"
            ---
             string.c                 | 6 +++++-
             test/ruby/test_string.rb | 3 +++
             2 files changed, 8 insertions(+), 1 deletion(-)

commit 1b5c74a2408d248f35cb811327dd51f49ee37c9e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-03-31 17:17:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-03-31 17:17:34 +0900

    merge revision(s) b14674b236445fb70f484603e678722760f678f4: [Backport #20194]

            Memory leak with TracePoint on bmethod

            [Bug #20194]

            When disabling the TracePoint on bmethod, the hooks list is not freed.

            For example:

                obj = Object.new
                obj.define_singleton_method(:foo) {}
                bmethod = obj.method(:foo)
                tp = TracePoint.new(:return) {}

                10.times do
                  100_000.times do
                    tp.enable(target: bmethod) {}
                  end

                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                18208
                22832
                26528
                29728
                34000
                37776
                40864
                44400
                47680
                51504

            After:

                16688
                17168
                17168
                17248
                17696
                17760
                17824
                17824
                17856
                17920
            ---
             test/ruby/test_settracefunc.rb | 13 +++++++++++++
             vm_trace.c                     |  1 +
             2 files changed, 14 insertions(+)

commit bf6e9299ef4f10dbd23f32331c355ac875bfb5e3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-03-31 17:16:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-03-31 17:16:26 +0900

    merge revision(s) 2554c5d3b8738a248cedb2fea96dfab9fbe19417: [Backport #20231]

            Don't wait in `io_binwrite_string` if not necessary. (#9792)

            ---
             io.c | 8 +++-----
             1 file changed, 3 insertions(+), 5 deletions(-)

commit d5dbada8a2127d9b6b670dd891eabbb63c48268f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-21 15:39:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-03-21 21:21:00 +0900

    Merge RDoc-6.5.1.1

commit 0a2238d509c158fb5539c0d7dd42d8e3faec6ead
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-03-21 21:15:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-03-21 21:15:02 +0900

    merge revision(s) 64b6a018a38f200c957fdbbe7d0cbe0e64781c9f:

            Fix test session reuse but expire (#9824)

            * OpenSSL 3.2.1 30 Jan 2024 is also broken

            Import 45064610725ddd81a5ea3775da35aa46985bc789 from ruby_3_3 branch
            tentatively.
            ---
             test/net/http/test_https.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit b12343c3b6c557b7e5668dcd8a9eab12fc9ee2c0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-03-10 19:12:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-03-10 19:12:31 +0900

    merge revision(s) d2cd903c85f38f42c6aefc6d97a1558f74d8d9db:

            [ruby/openssl] pkey/ec: constify

            https://github.com/ruby/openssl/commit/6fb3499a7b
            ---
             ext/openssl/ossl_pkey_ec.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 80112a9847b705b53e17e48540a6d00daa7e59a4
  Author:     Andrea Culot <andclt@amazon.com>
  AuthorDate: 2024-02-28 22:28:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-02-29 10:17:34 +0900

    Make sure RUBY_YJIT_ENABLE only enables YJIT for truthy values

commit 5e4606423da96c2e26b00981c22bddfce0d970bf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-02-25 18:29:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-02-25 18:29:16 +0900

    merge revision(s) f15123c34ce80f3928612befe2a9aaf4c9d27fda: [Backport #18743]

            Fix stack trace for rescued StopIteration

            ---
             enumerator.c                 | 15 +++++++++++++--
             test/ruby/test_enumerator.rb | 20 ++++++++++++++++++++
             2 files changed, 33 insertions(+), 2 deletions(-)

commit 1b9ff146e38c348519434754e0466352b8b25c50
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-02-25 14:03:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-02-25 14:03:05 +0900

    Revert "merge revision(s) c8d162c889008028b148437d02f36f4edaa749fd: [Backport #19973]"

    This reverts commit 24dd529750c08b5603fb418a4f34998b9bf6c8f9.

commit 24dd529750c08b5603fb418a4f34998b9bf6c8f9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-02-25 11:52:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-02-25 11:52:05 +0900

    merge revision(s) c8d162c889008028b148437d02f36f4edaa749fd: [Backport #19973]

            [Bug #19973] Warn duplicated keyword arguments after keyword splat

            ---
             parse.y                  | 11 +++++++----
             test/ruby/test_syntax.rb |  6 ++++++
             2 files changed, 13 insertions(+), 4 deletions(-)

commit 3960d894d98d20540e646a0d6c2186a2d676b96c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-02-25 00:23:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-02-25 00:23:21 +0900

    merge revision(s) 665b4c5b2a31078d7db0173ad60daad0b463c1fd,642875e474b4e6a13770b1dbbc33d466ba5e0718,54b9b80b84760717aadb8bf67f638785ed895a58,361bce8d2c4c90a01eb3b7365a87dec0d93bb2b6: [Backport #19967]

            [Bug #19967] Reset `LIBPATHENV` env after started

            Not to affect other tools invoked as child processes.
            ---
             common.mk            | 3 ++-
             template/Makefile.in | 3 +++
             template/fake.rb.in  | 3 +++
             tool/fake.rb         | 8 ++++++++
             4 files changed, 16 insertions(+), 1 deletion(-)

            [Bug #19967] Revert "configure.ac: LIBPATHENV on macOS"

            This reverts commit 1961c786aab243b3eb60e7238224e87975d88056.  These
            environment variables should no longer propagate to child processes.
            ---
             configure.ac | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            [Bug #19967] Delete real path

            ---
             tool/fake.rb | 3 ++-
             1 file changed, 2 insertions(+), 1 deletion(-)

            [Bug #19967] Ignore library before build

            ---
             tool/fake.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit aefc98891c42024039f19ef45bdfe93fbc590b7c
  Author:     Jun Aruga <jaruga@redhat.com>
  AuthorDate: 2024-01-04 01:34:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-01-31 19:43:45 +0900

    readline: Skip the test_interrupt_in_other_thread on arm32.

    Skip the test_interrupt_in_other_thread test failing on Travis arm32.
    The failing test is not a new issue. It had already been skipped in .travis.yml
    before updating .travis.yml.
    https://github.com/ruby/ruby/blob/7b05cb8dbbd637910757f402e64da3908b4bb809/.travis.yml#L99-L101

    Note that RUBY_PLATFORM is "armv8l-linux-eabihf" on Travis arm32 pipeline.
    And the readline was deleted in both master and ruby_3_3 branches.
    https://github.com/ruby/ruby/commit/59fd67fc3d405e529e038172e769ff20a8fb5535

    So, we only need this commit on ruby_3_2 and older Ruby version branches.

commit fc25e1662e88621178c15dbbb1a8b9cbc1cc4b13
  Author:     Jun Aruga <jaruga@redhat.com>
  AuthorDate: 2024-01-04 00:55:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-01-31 19:43:45 +0900

    Backport .travis.yml from ruby_3_3 branch.

    Update the .travis.yml file copied from the latest ruby_3_3 branch
    <5124f9ac7513eb590c37717337c430cb93caa151>.

commit 52bb2ac0a6971d0391efa2275f7a66bff319087c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-01-18 15:26:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-01-18 15:26:39 +0900

    bump teeny

commit 99c9aeef4b4417120e30b145cf98e1bc68a2a0de
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-01-18 12:57:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-01-18 12:57:01 +0900

    merge revision(s) b8a3f1bd456f92866c4a7bd83235f78c574784a8:

            Fix crash in tracing object allocations

            ObjectSpace.trace_object_allocations_start could crash since it adds a
            TracePoint for when objects are freed. However, TracePoint could crash
            since it modifies st tables while inside the GC that is trying to free
            the object. This could cause a memory allocation to happen which would
            crash if it triggers another GC.

            See a crash log: http://ci.rvm.jp/results/trunk@ruby-sp1/4373707
            ---
             ext/objspace/depend           | 1 +
             ext/objspace/object_tracing.c | 7 +++++++
             gc.h                          | 4 ++--
             3 files changed, 10 insertions(+), 2 deletions(-)

commit 3302e251dccec1e981945ab19d316d0856c68bf6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-01-18 11:56:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-01-18 11:56:43 +0900

    merge revision(s) e07e9f8491d9ab8b22d2bdf6a8aeba834dac7eef: [Backport #20174]

            RJIT: Do nothing on jit_cont_free

            if cont is NULL.
            ---
             cont.c | 2 ++
             1 file changed, 2 insertions(+)

commit 5dae6eb55e9785c8329708e55a49a280a344cdc1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-01-18 11:53:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-01-18 11:53:29 +0900

    merge revision(s) 051a874325c177e040301878069c2b28f5d06ce6: [Backport #20096]

            Fix memory overread in registry.rb

            The terminator is not actually getting filled in; we're simply passing
            (two) bytes of empty memory as the NUL terminator. This can lead to
            garbage characters getting written to registry values.

            Fix this by explicitly putting a WCHAR_NUL character into the string to
            be sent to the registry API, like we do in the MULTI_SZ case.

            [Bug #20096]
            ---
             ext/win32/lib/win32/registry.rb | 7 ++-----
             1 file changed, 2 insertions(+), 5 deletions(-)

commit a26b41bf7a2db69b0889ed599f568a4ba2529eba
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-01-18 11:51:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-01-18 11:51:58 +0900

    merge revision(s) 37ed86fd3c798e298fad9db6e7df1f3f45e1e03b: [Backport #20161]

            Fix memory leak in regexp grapheme clusters

            [Bug #20161]

            The cc->mbuf gets overwritten, so we need to free it to not leak memory.

            For example:

                str = "hello world".encode(Encoding::UTF_32LE)

                10.times do
                  1_000.times do
                    str.grapheme_clusters
                  end

                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                15536
                15760
                15920
                16144
                16304
                16480
                16640
                16784
                17008
                17280

            After:

                15584
                15584
                15760
                15824
                15888
                15888
                15888
                15888
                16048
                16112
            ---
             regparse.c | 3 ++-
             1 file changed, 2 insertions(+), 1 deletion(-)

commit b4f8623441a8be53b643fed826ba44e933cafd7e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-01-18 11:50:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-01-18 11:50:31 +0900

    merge revision(s) b3d612804946e841e47d14e09b6839224a79c1a4: [Backport #20150]

            Fix memory leak in grapheme clusters

            [Bug #20150]

            String#grapheme_cluters and String#each_grapheme_cluster leaks memory
            because if the string is not UTF-8, then the created regex will not
            be freed.

            For example:

                str = "hello world".encode(Encoding::UTF_32LE)

                10.times do
                  1_000.times do
                    str.grapheme_clusters
                  end

                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                26000
                42256
                59008
                75792
                92528
                109232
                125936
                142672
                159392
                176160

            After:

                9264
                9504
                9808
                10000
                10128
                10224
                10352
                10544
                10704
                10896
            ---
             string.c                 | 98 +++++++++++++++++++++++++++++++-----------------
             test/ruby/test_string.rb | 11 ++++++
             2 files changed, 75 insertions(+), 34 deletions(-)

commit 0cc0e43745ffc13a596441adccee295274d99a0b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2024-01-18 11:48:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2024-01-18 11:48:46 +0900

    merge revision(s) f9a48548cf3ef54fc0a385ccd78c708737055ecc: [Backport #20042]

            restore the stack pointer on finalizer

            When error on finalizer, the exception will be ignored.
            To restart the code, we need to restore the stack pointer.

            fix [Bug #20042]
            ---
             gc.c                 | 4 ++++
             test/ruby/test_gc.rb | 9 +++++++++
             2 files changed, 13 insertions(+)

commit 3bd9adadbe0b500cf7e910c99db97aaddfba3369
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-01-05 17:34:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-01-05 18:21:44 +0900

    Bump up net-http to 0.4.1

commit 671fd2a6323ab1b11fe2ba672ad22b7d3e87945e
  Author:     Sorah Fukumori <her@sorah.jp>
  AuthorDate: 2024-01-01 20:45:54 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-01-05 18:21:44 +0900

    [ruby/net-http] Renew test certificates

    The private key is replaced with a public known test key published at
    [RFC 9500].

    Also lifetime has been extended to 10 years from 4 years.

    [RFC 9500]: https://www.rfc-editor.org/rfc/rfc9500.html

    https://github.com/ruby/net-http/commit/4ab6c4a500

commit 041448de7d326c6f88f8f4d20f6a546646c1cbf7
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-01-05 17:09:21 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-01-05 18:21:44 +0900

    Bump up net-imap to 0.3.4.1

commit 152eadd37ce7697b6b1596733fb37e3d69b33253
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-01-05 16:51:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-01-05 18:21:44 +0900

    Bump up net-smtp to 0.3.4

commit 01d63a459027bf62548359f30d55321edd3f49c8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-01-05 14:40:07 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-01-05 18:21:44 +0900

    Bump up net-ftp to 0.2.1

commit 7b05cb8dbbd637910757f402e64da3908b4bb809
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:51:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:51:16 +0900

    NEWS.md: bump default gem net-http to 0.4.0

commit e7ad9a786dc4d4574f69629e9efa3d1d95413dca
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:45:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    merge revision(s) e3a19b8a4306ae3103e6a27cdac7482585aac453:

            [ruby/net-http] Bump up 0.4.0

            https://github.com/ruby/net-http/commit/4be99c204c
            ---
             lib/net/http.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit c5cea385a5e42e464b436844f0ae185b17a93eb9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:42:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    merge revision(s) 66d266244c00c1f9ffcfbd2970386e0adcc2512a:

            [ruby/net-http] Removed obsolated Revision constant

            https://github.com/ruby/net-http/commit/c1c5638014
            ---
             lib/net/http.rb | 1 -
             1 file changed, 1 deletion(-)

commit 4cbad13e9cd1c4cf63ad4adc096cc4b6294a838f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:42:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    merge revision(s) f109269a0392940df2b314e16502c4509b94a290,14fa5e39d72c84d3e12e10dc5d77a6e6200c10f5:

            [ruby/net-http] fix a false-negative test

            * no_proxy is meant to operate on the destination address, not on the name of the proxy
            * if both end with `'.example'`, the test does not nail down the behaviour

            https://github.com/ruby/net-http/commit/bb9a5cfa3d
            ---
             test/net/http/test_http.rb | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

            [ruby/net-http] fix no_proxy behaviour

            https://github.com/ruby/net-http/commit/f4951dc42a
            ---
             lib/net/http.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit b3639871b2566c25c6c3b547f57348dc101ed3a4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:41:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    merge revision(s) 3dec5dc3462286cdbdb53e496e6175a82bdc39b7:

            [ruby/net-http] Force TLS version to 1.2 when using LibreSSL

            This comment previously specified TLS 1.2, but actually set the
            version to TLS 1.0.  LibreSSL 3.8.1 (included in OpenBSD 7.4)
            dropped support for TLS 1.0/1.1 for security reasons, which
            broke this test.  Switch the test to use TLS 1.2 as documented
            so it will continue to work on OpenBSD 7.4+.

            https://github.com/ruby/net-http/commit/97be4de53a
            ---
             test/net/http/test_https.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 06051311d828bead3922ac5766822000c011e5db
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:40:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    merge revision(s) 9d58f9382893a71d8badad605879c0120915fbee:

            [ruby/net-http] Net::HTTPResponse nil checking

            Fix nil handling in read_body and stream_check.

            Fixes: #70

            https://github.com/ruby/net-http/commit/36f916ac18
            ---
             lib/net/http/response.rb           |  3 ++-
             test/net/http/test_httpresponse.rb | 35 +++++++++++++++++++++++++++++++++++
             2 files changed, 37 insertions(+), 1 deletion(-)

commit 359653658e604c075e3eca73e20b02d0d46bd0ef
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:39:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    merge revision(s) 8d04260acd8b6fba98867acc1a7e786495813fa0,2fbd8dca18a102cb3ffc5e7e6235c09fd0d04ba3,4165ec91d87ff1fcb41e312d896bea8a678c9bab,4d21134f3f1645ae2042d836e750ad267ee1551f,70da92cdf7ac75e071353c4551419ad02c284497,ea321a654d4b4fd6d56a1cdd6e117c62075898ee,ae68a8df586e9f3b3211e9c174b7001e57ee6aee,af67ced3b0945e8ea67434f8e66ef1e602656438,e77c766b7ab17e801c5cfa881754c392f8c13f0b:

            [ruby/net-http] turn on frozen strings for net/http/header

            https://github.com/ruby/net-http/commit/a5203c9f92
            ---
             lib/net/http/header.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            [ruby/net-http] turn on frozen strings for net/http/generic_request

            https://github.com/ruby/net-http/commit/b92ade088d
            ---
             lib/net/http/generic_request.rb | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

            [ruby/net-http] update net/http/response to be frozen string literal

            https://github.com/ruby/net-http/commit/dc3b4a75ca
            ---
             lib/net/http/response.rb | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

            [ruby/net-http] freeze rest of lib

            https://github.com/ruby/net-http/commit/455a74734a
            ---
             lib/net/http.rb             | 2 +-
             lib/net/http/backward.rb    | 2 +-
             lib/net/http/exceptions.rb  | 2 +-
             lib/net/http/proxy_delta.rb | 2 +-
             lib/net/http/request.rb     | 2 +-
             lib/net/http/requests.rb    | 2 +-
             lib/net/https.rb            | 2 +-
             7 files changed, 7 insertions(+), 7 deletions(-)

            [ruby/net-http] Fix on 2.7

            https://github.com/ruby/net-http/commit/5194fd541e
            ---
             lib/net/http.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            [ruby/net-http] use +'' everywhere

            https://github.com/ruby/net-http/commit/1077427152
            ---
             lib/net/http/generic_request.rb | 4 ++--
             lib/net/http/response.rb        | 2 +-
             2 files changed, 3 insertions(+), 3 deletions(-)

            [ruby/net-http] Update lib/net/http/response.rb

            @natematykiewicz's suggestion to avoid a string allocation

            https://github.com/ruby/net-http/commit/925630f227

            Co-authored-by: Nate Matykiewicz <natematykiewicz@gmail.com>
            ---
             lib/net/http/response.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            [ruby/net-http] Update lib/net/http.rb

            @natematykiewicz's suggestion to avoid another string allocation

            https://github.com/ruby/net-http/commit/4a22c42338

            Co-authored-by: Nate Matykiewicz <natematykiewicz@gmail.com>
            ---
             lib/net/http.rb | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

            [ruby/net-http] No longer neccessary to call `String#freeze` on
             string literals.

            See #144

            https://github.com/ruby/net-http/commit/5a986c13d3
            ---
             lib/net/http.rb                 | 2 +-
             lib/net/http/generic_request.rb | 8 ++++----
             2 files changed, 5 insertions(+), 5 deletions(-)

commit affd2c02962a83b353acd846d99500f3b7994009
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:36:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    merge revision(s) 0300ea5a6c8a7a49feed73318fc8a991aa89fcfc:

            [ruby/net-http] Improve performance of HTTPHeader#content_type

            In the existing implementation, `main_type` and `sub_type` would end up
            being called multiple times potentially.

            Instead of doing that, save the result so it can be re-used.

            https://github.com/ruby/net-http/commit/179976f7ea
            ---
             lib/net/http/header.rb | 12 ++++++++----
             1 file changed, 8 insertions(+), 4 deletions(-)

commit ca83700944623d5934a6979ed209733045ac541c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:36:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    partially merge revision cfa6a892d05c5dcbd8fcd7c78cdbac49a8ff6100:

    Redirect to  for the portability

commit e337b858343f12a2765505dc958ab22c7e134cc9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:32:50 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    merge revision(s) 1b4c1492c1704407f86af2882efebc047b9c2d26,62e2b61607c04ff0d2543f0515b2171a24e66b4e,fd0a5659cadb49f1640b20896cd750decdbbd701,c8c3431b0a5995d58f97c511ffa0a39e0f19c75e,755c379d877c66916d20840f07738d6050da3ca2,030f39822ac9d6d7dcdb639e099b320d3517c19c,2f19c5b7e080f75c3373c5b1671b4d4cfab6d334:

            [ruby/net-http] [DOC] What's Here for Net:HTTP
             (https://github.com/ruby/net-http/pull/128)

            https://github.com/ruby/net-http/commit/39e70f0f9b
            ---
             lib/net/http.rb | 269 +++++++++++++++++++++++++++++++++++++++++++++++++++++++-
             1 file changed, 267 insertions(+), 2 deletions(-)

            Replaced non-ascii charactor. It fails version detection at
             `net-http.gemspec`.

              >#   Returns the X509 certificate chain for the session<E2><80><99>s socket peer.
            ---
             lib/net/http.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            [ruby/net-http] Test building packages

            Also revert commit https://github.com/ruby/net-http/commit/d22ca54904de "Replaced
            non-ascii charactor. It fails version detection at `net-http.gemspec`."

            https://github.com/ruby/net-http/commit/fbeb247d93
            ---
             lib/net/http.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            [ruby/net-http] Read in binary mode to get rid of invalid byte
             sequence

            https://github.com/ruby/net-http/commit/38de3d17a7
            ---
             lib/net/http/net-http.gemspec | 11 ++++++++---
             1 file changed, 8 insertions(+), 3 deletions(-)

            [ruby/net-http] Exclude git related files

            https://github.com/ruby/net-http/commit/2767df580d
            ---
             lib/net/http/net-http.gemspec | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            [ruby/net-http] Re-apply
             https://github.com/ruby/net-http/commit/d22ca54904de after testing

            https://github.com/ruby/net-http/commit/7ac7401a9c
            ---
             lib/net/http.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            [ruby/net-http] Enhanced RDoc for Net::HTTP
             (https://github.com/ruby/net-http/pull/130)

            https://github.com/ruby/net-http/commit/698e18cfc1
            ---
             lib/net/http/response.rb | 53 ++++++++++++++++++++++++++++++++----------------
             1 file changed, 36 insertions(+), 17 deletions(-)

commit 0869dc58d601022f31065aa064b1cda02f53a7de
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:27:52 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    merge revision(s) 9cc0ac22f7c9f37aa7fadfe5606ce2feed260d2d:

            Update lib/net/http/status.rb

            ---
             lib/net/http/status.rb | 9 +++++----
             1 file changed, 5 insertions(+), 4 deletions(-)

commit f48a9bbb16fb369d614208a60a4b81ea024a67d1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:27:07 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    partially merge revision db0a4c8923e0e084c7d757d132a83fc9c8431633:

    Prefer to use File.foreach instead of IO.foreach

commit 74444d539dbb0c5c460f42cdaf0a23a59c10972f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-16 10:07:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-16 10:48:39 +0900

    merge revision(s) cd6c7613f31a371326d86de55af15918d6aa01f1:

            Apply the accidental commits again before Ruby 3.2.

              Reverts the following commits:

              eb8d4d7b5145849325985c00b810b8d75661d86e
              edb83dc3a2c374e880e8eb488152872152790e92
              d40064d1846b5835dff81e3f168c0c3a6c85e814
            ---
             ext/openssl/ossl_pkey_ec.c |   2 +-
             lib/erb.gemspec            |   2 +-
             lib/net/http/responses.rb  | 137 +++++++++++++++++++++++++++++++++++++++------
             3 files changed, 121 insertions(+), 20 deletions(-)

commit a77833b02d1cc33b26fc1ce5fa8be5eccef49dde
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-15 10:21:52 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-15 10:21:52 +0900

    Backport YJIT docs for Ruby 3.2 (#9245)

    * Backport YJIT docs for Ruby 3.2

    * Revert a change since ext/readline still exists in 3.2

commit f1097813a30ced07b324daa9699f07dba3b202fa
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-09 16:50:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-09 16:50:08 +0900

    merge revision(s) d8b8294c28a09278de357c26b291abf1b9f3cc5d,eedcd696a57521a18963d58487db8057a374a67a,bc0a7a641b6d0d3ff979cfa11e25683f8fa59ebd:

            [ruby/net-http] Limit header length

            https://github.com/ruby/net-http/commit/c245f7f9c8
            ---
             lib/net/http/header.rb | 8 ++++++++
             1 file changed, 8 insertions(+)

            [ruby/net-http] Fix previous commit

            https://github.com/ruby/net-http/commit/1b276e2654
            ---
             lib/net/http/header.rb | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

            [ruby/net-http] typofix

            https://github.com/ruby/net-http/commit/4d31bde125
            ---
             lib/net/http/header.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 4797127258f26ebac18d23c5715dde36b8a1b1ef
  Author:     MSP-Greg <Greg.mpls@gmail.com>
  AuthorDate: 2023-12-02 23:52:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-03 13:58:16 +0900

    [CI] windows.yml - use MSYS2 bison instead of Chocolatey

commit 82d39cb846748cd7de618b34b818f34d2c077e7e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-12-02 17:58:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-12-02 17:58:03 +0900

    merge revision(s) 6ebcf25de2859b5b6402b7e8b181066c32d0e0bf: [Backport #20036]

            GC guard catch_table_ary in iseq_set_exception_table

            The function iseq_set_exception_table allocates memory which can cause
            a GC compaction to run. Since catch_table_ary is not on the stack, it
            can be moved, which would make tptr incorrect.
            ---
             compile.c | 10 +++++++---
             1 file changed, 7 insertions(+), 3 deletions(-)

commit 1fe09feb065972a6b76ec2dfe0e3aa6bbdf37eb7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-11-21 22:06:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-11-21 22:06:00 +0900

    bump patchlevel. [Backport #20010]

commit 6ad47f356b8d6cafe2da6306aab801af406ee94e
  Author:     Bo Anderson <mail@boanderson.me>
  AuthorDate: 2023-11-21 22:04:00 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-11-21 22:04:00 +0900

    [3.2 backport] Fix compile error on older systems without clock_get* (#8948)

    Fix compile error on older systems without clock_get*

commit ba0de58de3bc891507f2d1dfffbe4ad632fdcd5c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-11-21 22:01:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-11-21 22:01:54 +0900

    merge revision(s) 8d1109c03bacc952b6218af2e4ae9b74c9855273:

            Added assertion values for Amazon Linux 2023

            ---
             spec/ruby/core/file/utime_spec.rb | 8 +++++---
             1 file changed, 5 insertions(+), 3 deletions(-)

commit d9f4f321c60ecd8f569c383a3a63f952fd764f48
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-11-19 22:02:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-11-19 22:02:55 +0900

    merge revision(s) 674db715f5a141891a66e67004ca138696d3b0ad,1f1b9b0942ec12dde1af8000f8cb84692904fccc:

            [ruby/rdoc] test/rdoc/test_rdoc_generator_json_index.rb: Use
             assert_equal instead of assert.

            It's better because assert_equal prints the values when it fails.

            https://github.com/ruby/rdoc/commit/91d40ce8f8
            ---
             test/rdoc/test_rdoc_generator_json_index.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            [ruby/rdoc] test/rdoc/test_rdoc_generator_json_index.rb: pend in
             test_generate in ppc64le.

            We observed that this test randomly fails in the ruby/ruby Travis ppc64le case.
            This commit is to pend the test_generate if the assertion for the generated
            file's modified time fails in a ppc64le environment.

            Note that I didn't use the word "Travis CI" or Travis CI specific environment variables
            such as `TRAVIS` and `TRAVIS_CPU_ARCH`[1] in the code. Because I wanted to prioritize the
            rdoc's independence from the ruby/ruby.

            [1] https://docs.travis-ci.com/user/environment-variables/#default-environment-variables

            https://github.com/ruby/rdoc/commit/42cdad1cf2
            ---
             test/rdoc/test_rdoc_generator_json_index.rb | 12 ++++++++++++
             1 file changed, 12 insertions(+)

commit 5e9948336e95ea8e5ff7f0554ae57be8d498af70
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-11-19 22:01:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-11-19 22:01:21 +0900

    merge revision(s) 3eaae72855b23158e2148566bb8a7667bfb395cb:

            test/fiber/test_queue.rb: Make the stuck test fail. (#8791)

            test/fiber/test_queue.rb: Make the stuck tests fail.

            We observed the 2 tests in the `test/fiber/test_queue.rb` getting stuck
            in some GCC compilers in Ubuntu ppc64le focal/jammy, even when the timeout
            `queue.pop(timeout: 0.0001)` is set in the code.

            This commit is to make the tests fail rather than getting stuck.
            ---
             test/fiber/test_queue.rb | 20 ++++++++++++++++----
             1 file changed, 16 insertions(+), 4 deletions(-)

commit 1cc38d5a2f84733e1c2e42548639e2891fe61e69
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-11-19 22:00:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-11-19 22:00:38 +0900

    merge revision(s) 9eac9d71786a8dbec520d0541a91149f01adf8ea: [Backport #19969]

            [Bug #19969] Compact st_table after deleted if possible

            ---
             hash.c                 | 19 +++++++++++++++++++
             st.c                   | 40 +++++++++++++++++++++++++++++-----------
             test/ruby/test_hash.rb |  9 +++++++++
             3 files changed, 57 insertions(+), 11 deletions(-)

commit 5baf94f9131fb45d50c8c408e007a138ced46606
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-11-18 11:28:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-11-18 12:06:27 +0900

    merge revision(s) 1f115f141dd17f75049a5e17107906c5bcc372e1:

            Speed up rebuilding the loaded feature index

            Rebuilding the loaded feature index slowed down with the bug fix
            for #17885 in 79a4484a072e9769b603e7b4fbdb15b1d7eccb15.  The
            slowdown was extreme if realpath emulation was used, but even when
            not emulated, it could be about 10x slower.

            This adds loaded_features_realpath_map to rb_vm_struct. This is a
            hidden hash mapping loaded feature paths to realpaths. When
            rebuilding the loaded feature index, look at this hash to get
            cached realpath values, and skip calling rb_check_realpath if a
            cached value is found.

            Fixes [Bug #19246]
            ---
             load.c    | 27 +++++++++++++++++++++++----
             vm.c      |  2 ++
             vm_core.h |  1 +
             3 files changed, 26 insertions(+), 4 deletions(-)

commit d1ba26a54d9301ea12fbc1b7d0e8223ce507de3b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-11-18 12:04:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-11-18 12:04:57 +0900

    Revert "merge revision(s) 9682275b5493439334fb3933ce2da3b95271eb1c: [Backport #19999]"

    This reverts commit 4b16259d1d6f408a88ac2c8d04ed78e87bdeda9f.

commit 4b16259d1d6f408a88ac2c8d04ed78e87bdeda9f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-11-18 11:41:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-11-18 11:41:58 +0900

    merge revision(s) 9682275b5493439334fb3933ce2da3b95271eb1c: [Backport #19999]

            [Travis] make `.bundle` directory writable

            To create gem files from sources under `gems/src` for tests.
            ---
             .travis.yml | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 482e1f573ee45ef562cc6d218ba26d44660f8e0a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-11-10 11:41:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-11-10 11:41:57 +0900

    merge revision(s) 17b0643392749f45b7aacb64fc1c1bd704d42b4c: [Backport #19924]

            [Bug #19924] Source code should be unsigned char stream

            Use `peekc` or `nextc` to fetch the next character, instead of reading
            from `lex.pcur` directly, for compilers that plain char is signed.
            ---
             parse.y                 | 10 +++++-----
             test/ruby/test_parse.rb |  2 ++
             2 files changed, 7 insertions(+), 5 deletions(-)

commit 2aaa9af75989bb0993a44e9690ed2ca890b2ff91
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-11-09 17:36:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-11-09 17:36:42 +0900

    merge revision(s) 4329554f171fdb483cafa672df5f2a08741940c5,b5c74d548872388921402ff2db36be15e924a89b: [Backport #19985]

            [Bug #19985] Raise LoadError with the converted feature name

            `Kernel#require` converts feature name objects that have the `to_path`
            method such as `Pathname`, but had used the original object on error
            and had resulted in an unexpected `TypeError`.
            ---
             load.c                    | 14 +++++++++++---
             test/ruby/test_require.rb | 26 +++++++++++++++++++++-----
             2 files changed, 32 insertions(+), 8 deletions(-)

            Ease the `Encoding::CompatibilityError` test failure

            At the time this test first started using `assert_raise_with_message`,
            it did not touch `Encoding.default_internal`.
            ---
             test/ruby/test_require.rb | 3 ++-
             1 file changed, 2 insertions(+), 1 deletion(-)

commit 8bbf909bb561732057b533cee1618b14886e07ba
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-10-28 11:39:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-10-28 11:57:52 +0900

    merge revision(s) 19346c2336053b351673da030b00c704138252d8: [Backport #19754]

            [Bug #19754] Make `IO::Buffer#get_string` check `offset` range
             (#8016)

            ---
             io_buffer.c                 | 3 +++
             test/ruby/test_io_buffer.rb | 8 ++++++++
             2 files changed, 11 insertions(+)

commit ddbab4f837460f070942e8127de9a9f1b9868fff
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-09-30 13:51:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-30 13:51:18 +0900

    merge revision(s) 6b66b5fdedb2c9a9ee48e290d57ca7f8d55e01a2: [Backport #19902]

            [Bug #19902] Update the coderange regarding the changed region

            ---
             ext/-test-/string/set_len.c       | 10 ++++++++++
             string.c                          | 27 +++++++++++++++++++++++++++
             test/-ext-/string/test_set_len.rb | 29 +++++++++++++++++++++++++++++
             3 files changed, 66 insertions(+)

commit 128d8728d39c2da21e5433c7af169f73e18fd133
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-09-30 13:48:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-30 13:48:45 +0900

    merge revision(s) ef59175a68c448fe334125824b477a9e1d5629bc: [Backport #19903]

            fix iseq kwargs table and original_iseq leaks

            [bug #19903]

            Co-authored-by: Peter Zhu <peter@peterzhu.ca>
            ---
             iseq.c | 4 ++++
             1 file changed, 4 insertions(+)

commit a191cf561786bde3d0b7d298aab1fbeb1051645c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-09-30 13:47:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-30 13:47:33 +0900

    merge revision(s) c42261059dfebabbf0391327a5e077545a9bc438: [Backport #19901]

            [Bug #19901]

            fix leak in module clone

            Co-authored-by: Peter Zhu <peter@peterzhu.ca>
            ---
             class.c                  |  1 +
             test/ruby/test_module.rb | 12 ++++++++++++
             2 files changed, 13 insertions(+)

commit 97b7070ebd5493de8d3a6a9b0ecc91bef5068d3f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-09-30 13:46:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-30 13:46:29 +0900

    merge revision(s) 8b236e0c66da8f92e9fc33de66cfbc8e4b0c0763: [Backport #19896]

            [Bug #19896]

            fix memory leak in vm_method

            This introduces a unified reference_count to clarify who is referencing a method.
            This also allows us to treat the refinement method as the def owner since it counts itself as a reference

            Co-authored-by: Peter Zhu <peter@peterzhu.ca>
            ---
             gc.c                     |   4 +-
             method.h                 |   6 +--
             rjit_c.rb                |   6 +--
             test/ruby/test_module.rb |   4 +-
             vm_insnhelper.c          |   2 +-
             vm_method.c              | 105 +++++++++++++++++++----------------------------
             6 files changed, 54 insertions(+), 73 deletions(-)

commit 5640baa2f82f528a092d92ceaabeb76c43c098ee
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-09-30 13:37:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-30 13:37:37 +0900

    merge revision(s) fe0225ff4d5af8b1f54009727b39d0d9b821eea3: [Backport #19778]

            [Bug #19778] Add `-I` options for opt-dir to `$INCFLAGS`

            These options have been separated from `$CFLAGS` already in the
            other places.
            ---
             configure.ac | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit e7ab923b880ac75862cf9c287ac8ecbcd8ed1a31
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-09-30 13:30:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-30 13:30:08 +0900

    merge revision(s) d4c720a91bc7bb9ff31810e1720acffb939f7a2f: [Backport #19845]

            Fix support for dynamic keys. (#8273)

            * Skip RBS test.
            ---
             cont.c                               |  8 +++-----
             spec/ruby/core/fiber/storage_spec.rb | 14 ++++++++++++++
             tool/rbs_skip_tests                  |  2 ++
             3 files changed, 19 insertions(+), 5 deletions(-)

commit d30781db4de82a891712f359d7659c9fc98cb215
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-09-30 13:07:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-30 13:07:35 +0900

    merge revision(s) 2214bcb70d9f9120f1f3790ca340236c8f080991: [Backport #19792]

            Fix premature string collection during append

            Previously, the following crashed due to use-after-free
            with AArch64 Alpine Linux 3.18.3 (aarch64-linux-musl):

            ```ruby
            str = 'a' * (32*1024*1024)
            p({z: str})
            ```

            32 MiB is the default for `GC_MALLOC_LIMIT_MAX`, and the crash
            could be dodged by setting `RUBY_GC_MALLOC_LIMIT_MAX` to large values.
            Under a debugger, one can see the `str2` of rb_str_buf_append()
            getting prematurely collected while str_buf_cat4() allocates capacity.

            Add GC guards so the buffer of `str2` lives across the GC run
            initiated in str_buf_cat4().

            [Bug #19792]
            ---
             string.c | 2 ++
             1 file changed, 2 insertions(+)

commit 9ee58b2054c1bbe722ae5a2a4ec6a750ee583220
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-09-24 15:13:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-24 15:13:32 +0900

    merge revision(s) 96c5a4be7b0d72502001734770af0f4a735c544c: [Backport #19894]

            Fix memory leak in complemented method entries

            [Bug #19894]

            When a copy of a complemented method entry is created, there are two
            issues:

            1. IMEMO_FL_USER3 is not copied, so the complemented status is not
               copied over.
            2. In rb_method_entry_clone we increment both alias_count and
               complemented_count. However, when we free the method entry in
               rb_method_definition_release, we only decrement one of the two
               counters, resulting in the rb_method_definition_t being leaked.

            Co-authored-by: Adam Hess <adamhess1991@gmail.com>
            ---
             method.h                 |  5 +++--
             test/ruby/test_module.rb | 29 +++++++++++++++++++++++++++++
             vm_method.c              |  8 +++++---
             3 files changed, 37 insertions(+), 5 deletions(-)

commit 9cd28caa7cc3b0d987db7c1231fe101fb3b27399
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-09-24 14:16:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-24 14:16:10 +0900

    merge revision(s) 901b6d9c5025a30b3d7a5ed0a2c00baf9cfb061d: [Backport #19853]

            Validate the typed data before dereferencing the internal struct.
             (#8315)

            ---
             process.c                  |  5 +++--
             test/fiber/test_process.rb | 21 +++++++++++++++++++++
             2 files changed, 24 insertions(+), 2 deletions(-)

commit 217ef2bf89b3861e83c2e2a3a633c019f0731de6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-09-24 13:48:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-24 13:48:08 +0900

    merge revision(s) 25711683e86271385e8abe09a9c03782000e48db: [Backport #19864]

            Fix regression when testing inclusion in unbounded ranges

            Caused by 04a92a6764bf678919cf4b68a27496a39d6b886a.  This treats
            unbounded ranges of arbitrary objects the same as how unbounded
            string ranges are treated:

              (..x)  === y  # (y <=> x) <= 0
              (...x) === y  # (y <=> x) <  0
              (x..)  === y  # (x <=> y) <= 0

            Fixes [Bug #19864]
            ---
             range.c                 |  9 +++++++++
             test/ruby/test_range.rb | 23 +++++++++++++++++++++++
             2 files changed, 32 insertions(+)

commit a7335e11e354d1ee2e15233f32f087230069ad5c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-09-16 14:17:20 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-09-16 14:17:20 +0900

    [Backport 3.2] Fix missing write barrier in iseq instruction list (#8431)

    Fix missing write barrier in iseq instruction list

    [Bug #19880]

    There's a missing write barrier for operands in the iseq instruction
    list, which can cause crashes.

    It can be reproduced when Ruby is compiled with `-DRUBY_DEBUG_ENV=1`.
    Using the following command:

    ```
    RUBY_GC_HEAP_OLDOBJECT_LIMIT_FACTOR=0 RUBY_DEBUG=gc_stress ruby -w --disable=gems -Itool/lib -W0 test.rb
    ```

    The following script crashes:

    ```
    require "test/unit"
    ```

commit e159971e03102090e29f3555975498f75cf02f2c
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2023-09-16 13:06:39 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-09-16 13:06:39 +0900

    [For ruby_3_2] Fix unused_mut Rust warnings (#8435)

    Fix unused_mut Rust warnings

    Rust version 1.71.0 and up issue these warnings. On GitHub CI, the
    warnings were previously seen in -DYJIT_FORCE_ENABLE runs.

commit bb877e5b4fe81965af60a0d86daeb8ed477e8e87
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-09-09 19:33:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-09 19:33:29 +0900

    merge revision(s) 382678d4112f4afc6272244c22924d2b004274b1: [Backport #19788]

            [Bug #19788] Use the result of `tCOLON2` event

            ---
             parse.y                            | 16 ++++++++--------
             test/ripper/test_parser_events.rb  | 17 +++++++++++++++++
             test/ripper/test_scanner_events.rb |  5 +++++
             3 files changed, 30 insertions(+), 8 deletions(-)

commit 0b7a4fbaa9c56d2c67d00d86c69f9e5c71803267
  Author:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  AuthorDate: 2023-08-18 22:19:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-09-09 18:51:25 +0900

    Allow waitpid(-1) to be woken if a waitpid(pid) call is pending

    If two threads are running, with one calling waitpid(-1), and another
    calling waitpid($some_pid), and then $some_other_pid exits, we would
    expect the waitpid(-1) call to retrieve that exit status; however, it
    cannot actually do so until $some_pid _also_ exits.

    This patch fixes the issue by unconditionally checking for pending
    process group waits on SIGCHLD, and then allowing pending pid-only waits
    to "steal" the notification.

    [Fixes #19387]

commit bbdffef63c55a594e604bd1ec5e90bffc6ea4c12
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-08-23 13:05:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-29 23:25:18 +0900

    Bump up bundler-2.4.19

commit ab1eacc8bc32a5604219878911ab1b3a92c320f6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-08-18 12:10:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-29 23:25:18 +0900

    Merge RubyGems-3.4.19 and Bundler-2.4.19

commit 1434059ab5006e32ad872a62e7f0ecca190194fb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-08-18 12:10:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-29 23:25:18 +0900

    Merge RubyGems-3.4.18 and Bundler-2.4.18

commit d6c3a1778c74431e68766db8a65eef77c8659661
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-07-19 14:15:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-29 23:25:18 +0900

    Merge RubyGems-3.4.17 and Bundler-2.4.17

commit 829048df2ff7f810b01bcf524086f891ee1ac5af
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-07-19 14:14:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-29 23:25:18 +0900

    Merge RubyGems-3.4.16 and Bundler-2.4.16

commit e44e42c3039d26c016554f3db1c0d6817abbad87
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-07-19 14:14:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-29 23:25:18 +0900

    Merge RubyGems-3.4.15 and Bundler-2.4.15

commit a36c8364331d39dd7da6308c6ae99f5a810ac510
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-07-19 14:13:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-29 23:25:18 +0900

    Merge RubyGems-3.4.14 and Bundler-2.4.14

commit 1b1a5b29843aba07e5a45f30ac1f23b1cb1e8173
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-07-19 14:13:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-29 23:25:18 +0900

    Merge RubyGems-3.4.13 and Bundler-2.4.13

commit c71a89f7854bd68bc631747681b4ea6c91d845d5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-07-19 14:12:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-29 23:25:18 +0900

    Merge RubyGems-3.4.12 and Bundler-2.4.12

commit dd91a17560946db1cb33c0ae1ecf3abe555ed1d0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-07-19 14:12:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-29 23:25:18 +0900

    Merge RubyGems-3.4.11 and Bundler-2.4.11

commit 5d568e18980b2fdec4701b52f2d89833fa20c0a8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-08-29 21:06:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-29 21:06:04 +0900

    merge revision(s) a28c5151f567cada0d2f5c0c3ec4df7f97b80784: [Backport #19855]

            Fix Array#bsearch when block returns a non-integer numeric value

            ---
             array.c                 | 4 ++--
             test/ruby/test_array.rb | 4 ++++
             2 files changed, 6 insertions(+), 2 deletions(-)

commit e777064e4b064fd77aca65c123f1919433f6732d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-08-24 14:56:50 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-24 16:06:32 +0900

    Revert "Re-apply "Ruby 3.2 - Speed up rebuilding the loaded feature index and realpath cache (#8023)" (#8252)"

    This reverts commit 788b03d5ba82fd8b35ce1fe2618ce6bacc648333.

commit 788b03d5ba82fd8b35ce1fe2618ce6bacc648333
  Author:     MSP-Greg <MSP-Greg@users.noreply.github.com>
  AuthorDate: 2023-08-22 08:33:47 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-08-22 08:33:47 +0900

    Re-apply "Ruby 3.2 - Speed up rebuilding the loaded feature index and realpath cache (#8023)" (#8252)

    * Re-apply "Ruby 3.2 - Speed up rebuilding the loaded feature index and realpath cache (#8023)"

    * [CI] mingw.yml - remove IBM437 encoding for test-all, use cmd shell for test & test-all

    * Skip failing test on mingw with readline.so

    Co-authored-by: nagachika <nagachika@ruby-lang.org>

    ---------

    Co-authored-by: nagachika <nagachika@ruby-lang.org>

commit e517ba2e5b6434e7d2370de7703f481dcb8eecba
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-06-01 17:05:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-20 13:26:54 +0900

    Bump up syntax_suggest-1.1.0

commit 0c908fa681271f13750aa64420203f1a58fa03fe
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-08-13 13:35:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-13 13:35:25 +0900

    merge revision(s) 0b8f15575a440f85ac686f5b0eae8f8b7c2b72e7: [Backport #19836]

            Fix memory leak for incomplete lambdas

            [Bug #19836]

            The parser does not free the chain of `struct vtable`, which causes
            memory leaks.

            The following script reproduces this issue:

            ```
            10.times do
              100_000.times do
                Ripper.parse("-> {")
              end

              puts `ps -o rss= -p #{$$}`
            end
            ```
            ---
             parse.y                    | 24 ++++++++++++++----------
             test/ripper/test_ripper.rb |  7 +++++++
             2 files changed, 21 insertions(+), 10 deletions(-)

commit 6898389a0f640c4155a7073579f43d1e16893698
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-08-13 13:21:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-13 13:21:30 +0900

    merge revision(s) 5bc8fceca8d47ed1ef9c603c6531a408de36b60c: [Backport #19835]

            Fix memory leak in parser for incomplete tokens

            [Bug #19835]

            The parser does not free the `tbl` of the `struct vtable` when there are
            leftover `lvtbl` in the parser. This causes a memory leak.

            The following script reproduces this issue:

            ```
            10.times do
              100_000.times do
                Ripper.parse("class Foo")
              end

              puts `ps -o rss= -p #{$$}`
            end
            ```
            ---
             parse.y                    | 42 ++++++++++++++++++++++++++++--------------
             test/ripper/test_ripper.rb |  7 +++++++
             2 files changed, 35 insertions(+), 14 deletions(-)

commit ead1a83b2f5951cd09667ed2722ab14b9bcf0834
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-08-12 13:54:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-12 13:54:17 +0900

    merge revision(s) 1b0da1e6236ad9a380abfe4ca8b51f06c34bb6f9:

            Skip running brew upgrade (#8189)

            This has been unstable:
            https://github.com/ruby/ruby/actions/runs/5797755676/job/15713988590

            and I'm not sure if we need that in the first place, assuming the
            OS image itself is maintained by GitHub.
            ---
             .github/actions/setup/macos/action.yml | 1 -
             1 file changed, 1 deletion(-)

commit b11f238a811513b31c4f65c822370ac470f438dc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-08-12 13:51:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-12 13:51:03 +0900

    merge revision(s) 72d1a790cfe0e4a457db98c587f1acaa5e39f001: [Backport #19833]

            [Bug #19833] Fix index underflow at superclasses of `BasicObject`

            ---
             object.c                | 4 ++++
             test/ruby/test_class.rb | 7 +++++++
             2 files changed, 11 insertions(+)

commit 3c9cb7031154b8666d600b0055ba868e18805dc8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-08-12 13:48:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-12 13:48:14 +0900

    merge revision(s) 1d096c1e53581ed9fe94694c9760babd1e12e580: [Backport #19793]

            Fix crash in NoMethodError for dummy frames
            MIME-Version: 1.0
            Content-Type: text/plain; charset=UTF-8
            Content-Transfer-Encoding: 8bit

            [Bug #19793]

            Dummy frames are created at the top level when requiring another file.
            While requiring a file, it will try to convert using encodings. Some of
            these encodings will not respond to to_str. If method_missing is
            redefined on Object, then it will call method_missing and attempt raise
            an error. However, the iseq is invalid as it's a dummy frame so it will
            write an invalid iseq to the created NoMethodError.

            The following script crashes:

            ```
            GC.stress = true

            class Object
              public :method_missing
            end

            File.write("/tmp/empty.rb", "")
            require "/tmp/empty.rb"
            ```

            With the following backtrace:

            ```
            frame #0: 0x00000001000fa8b8 miniruby`RVALUE_MARKED(obj=4308637824) at gc.c:1638:12
            frame #1: 0x00000001000fb440 miniruby`RVALUE_BLACK_P(obj=4308637824) at gc.c:1763:12
            frame #2: 0x00000001000facdc miniruby`gc_writebarrier_incremental(a=4308637824, b=4308332208, objspace=0x000000010180b000) at gc.c:8822:9
            frame #3: 0x00000001000faad8 miniruby`rb_gc_writebarrier(a=4308637824, b=4308332208) at gc.c:8864:17
            frame #4: 0x000000010016aff0 miniruby`rb_obj_written(a=4308637824, oldv=36, b=4308332208, filename="../iseq.c", line=1279) at gc.h:804:9
            frame #5: 0x0000000100162a60 miniruby`rb_obj_write(a=4308637824, slot=0x0000000100d09888, b=4308332208, filename="../iseq.c", line=1279) at gc.h:837:5
            frame #6: 0x0000000100165b0c miniruby`iseqw_new(iseq=0x0000000100d09880) at iseq.c:1279:9
            frame #7: 0x0000000100165a64 miniruby`rb_iseqw_new(iseq=0x0000000100d09880) at iseq.c:1289:12
            frame #8: 0x00000001000d8324 miniruby`name_err_init_attr(exc=4309777920, recv=4304780496, method=827660) at error.c:1830:35
            frame #9: 0x00000001000d1b80 miniruby`name_err_init(exc=4309777920, mesg=4308332496, recv=4304780496, method=827660) at error.c:1869:12
            frame #10: 0x00000001000d1bd4 miniruby`rb_nomethod_err_new(mesg=4308332496, recv=4304780496, method=827660, args=4308332448, priv=0) at error.c:1957:5
            frame #11: 0x000000010039049c miniruby`rb_make_no_method_exception(exc=4304914512, format=4308332496, obj=4304780496, argc=1, argv=0x000000016fdfab00, priv=0) at vm_eval.c:959:16
            frame #12: 0x00000001003b3274 miniruby`raise_method_missing(ec=0x0000000100b06f40, argc=1, argv=0x000000016fdfab00, obj=4304780496, last_call_status=MISSING_NOENTRY) at vm_eval.c:999:15
            frame #13: 0x00000001003945d4 miniruby`rb_method_missing(argc=1, argv=0x000000016fdfab00, obj=4304780496) at vm_eval.c:944:5
            ...
            frame #23: 0x000000010038f5e4 miniruby`rb_vm_call_kw(ec=0x0000000100b06f40, recv=4304780496, id=2865, argc=1, argv=0x000000016fdfab00, me=0x0000000100cbfcf0, kw_splat=0) at vm_eval.c:326:12
            frame #24: 0x00000001003c18e4 miniruby`call_method_entry(ec=0x0000000100b06f40, defined_class=4304927952, obj=4304780496, id=2865, cme=0x0000000100cbfcf0, argc=1, argv=0x000000016fdfab00, kw_splat=0) at vm_method.c:2720:20
            frame #25: 0x00000001003c440c miniruby`check_funcall_exec(v=6171896792) at vm_eval.c:589:12
            frame #26: 0x00000001000dec00 miniruby`rb_vrescue2(b_proc=(miniruby`check_funcall_exec at vm_eval.c:587), data1=6171896792, r_proc=(miniruby`check_funcall_failed at vm_eval.c:596), data2=6171896792, args="Pȗ") at eval.c:919:18
            frame #27: 0x00000001000deab0 miniruby`rb_rescue2(b_proc=(miniruby`check_funcall_exec at vm_eval.c:587), data1=6171896792, r_proc=(miniruby`check_funcall_failed at vm_eval.c:596), data2=6171896792) at eval.c:900:17
            frame #28: 0x000000010039008c miniruby`check_funcall_missing(ec=0x0000000100b06f40, klass=4304923536, recv=4304780496, mid=3233, argc=0, argv=0x0000000000000000, respond=-1, def=36, kw_splat=0) at vm_eval.c:666:15
            frame #29: 0x000000010038fa60 miniruby`rb_check_funcall_default_kw(recv=4304780496, mid=3233, argc=0, argv=0x0000000000000000, def=36, kw_splat=0) at vm_eval.c:703:21
            frame #30: 0x000000010038fb04 miniruby`rb_check_funcall(recv=4304780496, mid=3233, argc=0, argv=0x0000000000000000) at vm_eval.c:685:12
            frame #31: 0x00000001001c469c miniruby`convert_type_with_id(val=4304780496, tname="String", method=3233, raise=0, index=-1) at object.c:3061:15
            frame #32: 0x00000001001c4a4c miniruby`rb_check_convert_type_with_id(val=4304780496, type=5, tname="String", method=3233) at object.c:3153:9
            frame #33: 0x00000001002d59f8 miniruby`rb_check_string_type(str=4304780496) at string.c:2571:11
            frame #34: 0x000000010014b7b0 miniruby`io_encoding_set(fptr=0x0000000100d09ca0, v1=4304780496, v2=4, opt=4) at io.c:11655:19
            frame #35: 0x0000000100139a58 miniruby`rb_io_set_encoding(argc=1, argv=0x000000016fdfb450, io=4308334032) at io.c:13497:5
            frame #36: 0x00000001003c0004 miniruby`ractor_safe_call_cfunc_m1(recv=4308334032, argc=1, argv=0x000000016fdfb450, func=(miniruby`rb_io_set_encoding at io.c:13487)) at vm_insnhelper.c:3271:12
            ...
            frame #43: 0x0000000100390b08 miniruby`rb_funcall(recv=4308334032, mid=16593, n=1) at vm_eval.c:1137:12
            frame #44: 0x00000001002a43d8 miniruby`load_file_internal(argp_v=6171899936) at ruby.c:2500:5
            ...
            ```
            ---
             error.c                   |  4 +++-
             test/ruby/test_require.rb | 15 +++++++++++++++
             2 files changed, 18 insertions(+), 1 deletion(-)

commit 19823032abc2d1827a2aaf41bf3a3948afad8feb
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-08-12 13:46:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-08-12 13:46:25 +0900

    merge revision(s) 954b7ac81ef503df3c1efc5566df985b08951d52: [Backport #19789]

            addr2line.c: fix `DW_FORM_ref_addr` parsing for DWARF 2 (#8146)

            addr2line.c: fix DW_FORM_ref_addr parsing for DWARF 2

            This fixes a crash when retrieving backtrace info with YJIT enabled on
            macOS with Rust 1.71.0. Since Rust 1.71.0, the DWARF info generated by
            the Rust compiler uses DW_FORM_ref_addr instead of DW_FORM_ref4 for
            pointers to other DIEs.
            DW_FORM_ref_addr representation in DWARF 2 is different from DWARF 3+,
            so we need to handle it separately.
            This patch fixes the parsing of DW_FORM_ref_addr for DWARF 2, which is
            the default DWARF version Rustc uses on macOS.

            See the DWARF 2.0.0 spec, section 7.5.4 Attribute Encodings
            https://dwarfstd.org/doc/dwarf-2.0.0.pdf

            https://bugs.ruby-lang.org/issues/19789
            ---
             addr2line.c | 40 ++++++++++++++++++++++++++--------------
             1 file changed, 26 insertions(+), 14 deletions(-)

commit 1c7624469880bcb964be09a49e4907873f45b026
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-29 17:58:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-29 17:58:42 +0900

    Revert "Ruby 3.2 - Speed up rebuilding the loaded feature index and realpath cache (#8023)"

    This reverts commit 8346d1630b8193eef1ec9dd537b16de74afdc2e8.
    It seems break CI on MinGW.
    https://github.com/ruby/ruby/actions/runs/5698775895/job/15447455988

commit 8346d1630b8193eef1ec9dd537b16de74afdc2e8
  Author:     Kerem Kat <keremkat@gmail.com>
  AuthorDate: 2023-07-29 14:27:11 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-07-29 14:27:11 +0900

    Ruby 3.2 - Speed up rebuilding the loaded feature index and realpath cache (#8023)

    * Speed up rebuilding the loaded feature index

    Rebuilding the loaded feature index slowed down with the bug fix
    for #17885 in 79a4484a072e9769b603e7b4fbdb15b1d7eccb15.  The
    slowdown was extreme if realpath emulation was used, but even when
    not emulated, it could be about 10x slower.

    This adds loaded_features_realpath_map to rb_vm_struct. This is a
    hidden hash mapping loaded feature paths to realpaths. When
    rebuilding the loaded feature index, look at this hash to get
    cached realpath values, and skip calling rb_check_realpath if a
    cached value is found.

    Fixes [Bug #19246]

    * Add a realpath cache to reduce number of syscalls.

    Number of lstat and stat syscalls for each 'require'd file is doubled,
    because rb_realpath_internal is called from two places with the same
    arguments in require_internal; once for checking the realpaths cache,
    and once in load_iseq_eval when iseq is not found.

    Introduce rb_realpath_internal_cached function to reuse the realpath_map
    cache which memoizes rb_realpath_internal function, leading to less
    syscalls and increased startup performance depending on the cost of the syscalls
    in a particular environment.

    ---------

    Co-authored-by: Jeremy Evans <code@jeremyevans.net>

commit 19a3466a1460924058ca16a259601bb753293d43
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-29 14:04:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-29 14:04:01 +0900

    merge revision(s) cada537040743cbe49aac6740816d648ca0d3fb: [Backport #19786]

            [DOC] Fix call-seq for Data.define

            ---
             struct.c | 4 +---
             1 file changed, 1 insertion(+), 3 deletions(-)

commit 9f5c32ce85db830459768c588b82a6d07f5d22dc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-29 13:54:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-29 13:54:10 +0900

    merge revision(s) 99162dee7aa478d8a65f028b098bdaa69e1ecad5: [Backport #19751]

            [Bug #19751] Remove linemarkers in middle

            ---
             template/fake.rb.in | 1 +
             1 file changed, 1 insertion(+)

commit 0b3ed6043c9d091d499ca1caed604a983c7e285b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-23 12:20:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-23 12:20:12 +0900

    merge revision(s) 5d4fff845602872eef072e7611558b5f8762efe0: [Backport #19293]

            Tighten Time.new(string) parsing

            Disallow:

            * Only year-month
            * Only year-month-day
            * Preceding whitespace
            * Trailing whitespace

            Fixes [Bug #19293]
            ---
             test/ruby/test_time.rb | 13 +++++++++++++
             time.c                 | 13 ++++++++++++-
             2 files changed, 25 insertions(+), 1 deletion(-)

commit 3354aacb73c65420a10cb41c0696e62dd1ba279b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-23 12:01:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-23 12:01:21 +0900

    merge revision(s) 3874381c4483ba7794ac2abf157e265546f9bfa7: [Backport #19759]

            Fix autosplat conditions to handle ruby2_keywords case

            Autosplat should not occur if there are two arguments but second
            argument is an array containing a ruby2_keywords splat. Only
            autosplat if a single argument to be yielded to the block, and there
            is no splatted flagged keyword hash passed.

            Fixes [Bug #19759]
            ---
             test/ruby/test_proc.rb | 26 ++++++++++++++++++++++++++
             vm_args.c              |  3 ++-
             2 files changed, 28 insertions(+), 1 deletion(-)

commit b97a744a3778abe52fffb051e1460a0a6f7c4a6d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-22 14:01:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-22 14:01:55 +0900

    merge revision(s) 9c94db7cfc584e982a6449b72e58a1cf25024177,fe4d906f5fbacbe6e9267af3bd3503339bad63a9: [Backport #19774]

            Add tests for `return` in `BEGIN` and `END` blocks

            ---
             spec/ruby/language/return_spec.rb | 15 +++++++++++++++
             test/ruby/test_syntax.rb          |  1 +
             2 files changed, 16 insertions(+)

            [Bug #19774] Fix segfault at `return` in `END`

            ---
             eval_error.c             | 7 ++++++-
             test/ruby/test_syntax.rb | 5 +++++
             2 files changed, 11 insertions(+), 1 deletion(-)

commit 65d294ad019c8ac5bba12e2c9098360bacafc9e3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-22 13:39:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-22 13:39:44 +0900

    merge revision(s) bc3ac1872e4523334e3ed04c2bb70a55c4c43f98: [Backport #19748]

            [Bug #19748] Fix out-of-bound access in `String#byteindex`

            ---
             string.c                 | 17 +++++++----------
             test/ruby/test_string.rb |  3 +++
             2 files changed, 10 insertions(+), 10 deletions(-)

commit 35cf3a5f8d01aad07762eb824c3107bee9ae7fdd
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-22 13:32:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-22 13:32:30 +0900

    merge revision(s) 038f9ade3c4d965415e4956561975454cf9eeb21: [Backport #19585]

            Use tools appropriate with CC

            To get rid of mysterious errors such as:

            ```
            /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/bin/nm: error: libruby.3.3-static.a(/): The end of the file was unexpectedly encountered
            ```

            and

            ```
            ld: warning: ignoring file ../../libruby.3.3-static.a, building for macOS-x86_64 but attempting to link with file built for macOS-x86_64
            Undefined symbols for architecture x86_64:
              "_rb_rational_num", referenced from:
            ```
            ---
             configure.ac | 6 ++++++
             1 file changed, 6 insertions(+)

commit 4e0653db3315e9e7859e38e0995e2b9900471370
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-22 13:31:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-22 13:31:34 +0900

    merge revision(s) 2c8f2871a8aeff592369a993b1d69557160cfa61: [Backport #19532]

            Fix handling of 6-byte codepoints in left_adjust_char_head in CESU-8
             encoding

            ---
             enc/cesu_8.c                | 23 +++++++++++++++++++----
             test/ruby/enc/test_cesu8.rb |  4 ++++
             2 files changed, 23 insertions(+), 4 deletions(-)

commit fa72ba72f8c64fd0fa87c8f68cbc31f2e7b94b00
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-22 13:24:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-22 13:24:55 +0900

    merge revision(s) 54dbd8bea8a79bfcdefa471c1717c6cd28022f33: [Backport #19535]

            Use an st table for "too complex" objects

            st tables will maintain insertion order so we can marshal dump / load
            objects with instance variables in the same order they were set on that
            particular instance

            [ruby-core:112926] [Bug #19535]

            Co-Authored-By: Jemma Issroff <jemmaissroff@gmail.com>
            ---
             gc.c                     | 10 ++++------
             include/ruby/st.h        |  2 ++
             object.c                 |  2 +-
             ractor.c                 | 43 ++++++++++++++++++++++---------------------
             shape.h                  |  6 +++---
             st.c                     |  6 ++++++
             test/ruby/test_shapes.rb | 21 +++++++++++++++++++++
             variable.c               | 28 ++++++++++++++--------------
             vm_insnhelper.c          |  2 +-
             9 files changed, 74 insertions(+), 46 deletions(-)

commit a3911b965f094f07080cf7adb22ee5e2e8555d86
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-22 13:08:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-22 13:08:16 +0900

    merge revision(s) 0402193723647b8c4f57b1453fe2192ad2788d12: [Backport #19709]

            Fix `Thread#join(timeout)` when running inside the fiber scheduler.
             (#7903)

            ---
             test/fiber/test_thread.rb | 22 ++++++++++++++++++++++
             thread.c                  |  5 +++++
             2 files changed, 27 insertions(+)

commit ea89527a76a84741463c304246db2dd3a5df845b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-22 13:03:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-22 13:03:22 +0900

    merge revision(s) 0b2613f44309bddae45562c9f3a14ed43e56959b: [Backport #19640]

            `rb_io_puts` should not write zero length strings. (#7806)

            ---
             io.c                  | 40 ++++++++++++++++++++++++----------------
             test/fiber/test_io.rb | 28 ++++++++++++++++++++++++++++
             2 files changed, 52 insertions(+), 16 deletions(-)

commit 465eb7418d7ed91f5f0c75da77765c7f5ef8354f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-22 11:55:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-22 11:55:49 +0900

    merge revision(s) 91c004885fc75a93cadf0094fa86ec3bd0ec25f5: [Backport #19025]

            [Bug #19025] Numbered parameter names are always local variables

            ---
             parse.y                  | 2 +-
             test/ruby/test_syntax.rb | 1 +
             2 files changed, 2 insertions(+), 1 deletion(-)

commit e65e0b99267c495186d7abb78c2725418761d756
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-22 11:48:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-22 11:48:47 +0900

    merge revision(s) fac814c2dc31afef272b45392a7389ef0bfa3a4f: [Backport #19602]

            Fix `PLATFORM_GET_INC`

            On platforms where unaligned word access is not allowed, and if
            `sizeof(val)` and `sizeof(type)` differ:

            - `val` > `type`, `val` will be a garbage.
            - `val` < `type`, outside `val` will be clobbered.
            ---
             regexec.c | 2 +-
             regint.h  | 9 ++++++++-
             2 files changed, 9 insertions(+), 2 deletions(-)

commit 46b62f44ce30bf234a76114c8249081e47ce3da4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-22 11:44:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-22 11:44:54 +0900

    merge revision(s) 3592b24cdc07ed89eecb39161f21fe721a89a5de: [Backport #19531]

            ObjectSpace::WeakMap: clean inverse reference when an entry is
             re-assigned

            [Bug #19531]

            ```ruby
            wmap[1] = "A"
            wmap[1] = "B"
            ```

            In the example above, we need to remove the `"A" => 1` inverse reference
            so that when `"A"` is GCed the `1` key isn't deleted.
            ---
             test/ruby/test_weakmap.rb | 17 +++++++++
             weakmap.c                 | 91 ++++++++++++++++++++++++++++++++++++++---------
             2 files changed, 91 insertions(+), 17 deletions(-)

commit 3f6187a94797d3c4a7db00563a885e4e613b51cf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 18:04:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 18:04:41 +0900

    merge revision(s) 1bc8838d60ef3fc6812d3b64ed87caaf0ae943d9: [Backport #19750]

            Handle unterminated unicode escapes in regexps

            This fixes an infinite loop possible after ec3542229b29ec93062e9d90e877ea29d3c19472.
            For \u{} escapes in regexps, skip validation in the parser, and rely on the regexp
            code to handle validation. This is necessary so that invalid unicode escapes in
            comments in extended regexps are allowed.

            Fixes [Bug #19750]

            Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
            ---
             parse.y                 | 97 ++++++++++++++++++++++++++++++++-----------------
             test/ruby/test_parse.rb | 16 ++++++++
             2 files changed, 79 insertions(+), 34 deletions(-)

commit aef53162249ce090568e24a70e6d26b85bf399d6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 17:30:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 17:30:42 +0900

    Fixup be09d77b966c7bcc77957927f16cefe66b365495.

commit be09d77b966c7bcc77957927f16cefe66b365495
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 17:23:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 17:23:31 +0900

    merge revision(s) a8ba1ddd78544b4bda749051d44f7b2a8a0ec5ff: [Backport #19455]

            Use UTF-8 encoding for literal extended regexps with UTF-8 characters
             in comments

            Fixes [Bug #19455]
            ---
             re.c                     | 9 ++++++++-
             test/ruby/test_regexp.rb | 7 +++++++
             2 files changed, 15 insertions(+), 1 deletion(-)

commit 5fbd72764e020c6b165604e9cdcc932a1c5d2a93
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 17:21:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 17:21:51 +0900

    merge revision(s) 31e67a476f2262e01a0829e8ab5e6d8a97e0724e,0b95cbcbde8875effdbcbb676cb0a7f751a1d4c1: [Backport #19601]

            YJIT: Fix false object collection when setting ivar

            Previously, setinstancevariable could generate code that calls
            `rb_ensure_iv_list_size()` without first updating `cfp->sp`. This means
            in the event that a GC start from within said routine the top few
            objects would not be marked, causing them to be falsly collected.

            Call `jit_prepare_routine_call()` first.

            [Bug #19601]
            ---
             bootstraptest/test_yjit.rb | 20 ++++++++++++++++++++
             yjit/src/codegen.rs        |  5 +++++
             2 files changed, 25 insertions(+)

            YJIT: Remove duplicate `asm.spill_temps()`

            `jit_prepare_routine_call()` calls it, and there is another call above on line 2302.

            Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>
            ---
             yjit/src/codegen.rs | 1 -
             1 file changed, 1 deletion(-)

commit 5fc9825ccf651664c547b1822c7f753464e27f06
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 16:09:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 16:09:00 +0900

    merge revision(s) 02a7e12b80823919fb614ad3ea6241d5115d14fe: [Backport #19593]

            Ensure throw data is not set as cause

            [Bug #19593]

            rb_ec_setup_exception did not check if errinfo is a throw_data. This can
            cause crashes in code since it is assumed that id_cause is an object.

            We saw a crash in show_cause due to id_cause of errinfo being a
            throw_data. It crashes on rb_obj_is_kind_of since it cannot be called on
            T_IMEMO objects.

            Unfortunately, we couldn't find a reproduction script, however we
            debugged the core dump and rb_ec_setup_exception is the only place where
            id_cause is assigned from errinfo without checking if it is a
            throw_data.

            ```
            0x0000556c5708e6dd in sigsegv (sig=11, info=0x7f301befa3f0, ctx=0x7f301befa2c0) at signal.c:964
            0x00007f301d046420 in <signal handler called> () at /lib/x86_64-linux-gnu/libpthread.so.0
            class_search_class_ancestor (c=139844586301760, cl=<optimized out>) at object.c:810
            rb_obj_is_kind_of (obj=obj@entry=139839221734880, c=139844586301760) at object.c:861
            0x0000556c56f2f00f in show_cause
                (errinfo=errinfo@entry=139838840645160, str=str@entry=139839221730520, opt=139839221730480, highlight=0, reverse=reverse@entry=0, backtrace_limit=backtrace_limit@entry=-1, shown_causes=0x7ffe9d1a2d68) at ./include/ruby/internal/special_consts.h:175
            ```

            Co-Authored-By: Jean Boussier <byroot@ruby-lang.org>
            ---
             eval.c | 4 ++++
             1 file changed, 4 insertions(+)

commit 5328c58c7d00540f4f56749aaeefb68761bd7eba
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 16:07:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 16:07:39 +0900

    merge revision(s) 1a149aab776aa6741628eb35482eff1ded197fd2,fb17c833f542222afdf482924877d43aa577782d,60f22ebf86248388b41b4ec751d16700f2b4b621: [Backport #19533]

            Extract range type check functions

            ---
             range.c | 55 ++++++++++++++++++++++++++++++++++++-------------------
             1 file changed, 36 insertions(+), 19 deletions(-)

            [Bug #19533] Fix infinite range inclusion with numeric value

            ---
             range.c                 | 10 +++++++---
             test/ruby/test_range.rb |  2 ++
             2 files changed, 9 insertions(+), 3 deletions(-)

            [Bug #19533] Add spec of infinite range inclusion

            ---
             spec/ruby/core/range/case_compare_spec.rb | 6 ++++++
             1 file changed, 6 insertions(+)

commit 8165db0f4666f90fe0df5cdd466f73c6de1f6cea
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 14:21:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 14:21:39 +0900

    merge revision(s) 8c360ce713f57d4177de833297364f6f6d950420: [Backport #19589]

            hash.c: Fix hash_iter_lev_dec corrupting shape

            [Bug #19589]

            When decrementing `iter_lev` from `65` to `64` the flags would be
            corrupted, causing the shape_id to be invalid.
            ---
             hash.c                 | 12 +++++++++---
             test/ruby/test_hash.rb | 11 +++++++++++
             2 files changed, 20 insertions(+), 3 deletions(-)

commit a7b0d3c9db9afeccf6e0962bb1cdcbea5bf04cae
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 14:20:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 14:20:00 +0900

    merge revision(s) 0ac3f2c20e50c22d298238f602f25f84248ac7a5: [Backport #19587]

            [Bug #19587] Fix `reset_match_cache` arguments

            ---
             regexec.c                | 2 +-
             test/ruby/test_regexp.rb | 8 ++++++++
             2 files changed, 9 insertions(+), 1 deletion(-)

commit 0c5d539421e50351ed26fbf9cac852d58425776a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 14:09:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 14:09:11 +0900

    Fixup the latest commits.

commit 8852b4b2deea20f488208dc4730ef149f67d7594
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 13:59:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 13:59:25 +0900

    merge revision(s) 0ce2bdc76dd17aa3d42a352a6244c87a51e7606d: [Backport #19595]

            YJIT: Fix missing argc check in known cfuncs

            Previously we were missing a compile-time check that the known cfuncs
            receive the correct number of arguments.

            We noticied this because in particular when using ARGS_SPLAT, which also
            wasn't checked, YJIT would crash on code which was otherwise correct
            (didn't raise exceptions in the VM).

            This still supports vararg (argc == -1) cfuncs. I added an additional
            assertion that when we use the specialized codegen for one of these
            known functions that the argc are popped off the stack correctly, which
            should help ensure they're implemented correctly (previously the crash
            was usually observed on a future `leave` insn).

            [Bug #19595]
            ---
             bootstraptest/test_yjit.rb | 32 ++++++++++++++++++++++++++++++++
             yjit/src/codegen.rs        |  4 +++-
             2 files changed, 35 insertions(+), 1 deletion(-)

commit 9d8d0585ec35070099e4fdeef5ee18f6fbf339b6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 09:54:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 09:54:51 +0900

    merge revision(s) f6adc5be94a9f70a5b9897b81dabdeb49b573393,bccdc041665032b819fab1c04ed4dbdfeeeb366b: [Backport #19582]

            Check if Bundler is defined

            ---
             tool/lib/leakchecker.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            Check if `Bundler::EnvironmentPreserver` is defined

            Only `Bundler` might be defined.  `EnvironmentPreserver` and its
            `BUNDLER_PREFIX` would be defined together in the same file.
            ---
             tool/lib/leakchecker.rb | 5 ++++-
             1 file changed, 4 insertions(+), 1 deletion(-)

commit 62763658d53a66ad624e1c730742cb3811d18329
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 09:51:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 09:51:53 +0900

    merge revision(s) 52e571fa72debcd764765775bd1b76ee87e36d2d: [Backport #19580]

            Ensure ruby_xfree won't segfault if called after vm_destruct

            [Bug #19580]

            The real-world scenario motivating this change is libxml2's pthread
            code which uses `pthread_key_create` to set up a destructor that is
            called at thread exit to free thread-local storage.

            There is a small window of time -- after ruby_vm_destruct but before
            the process exits -- in which a pthread may exit and the destructor is
            called, leading to a segfault.

            Please note that this window of time may be relatively large if
            `atexit` is being used.
            ---
             gc.c | 12 ++++++++++--
             1 file changed, 10 insertions(+), 2 deletions(-)

commit 98b4ac7287928c202c90e9de1ae02c0707ec68b8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 09:50:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 09:50:10 +0900

    merge revision(s) 537183cd2ac0163851277b46a2f21ea5914c11c0: [Backport #19577]

            Fix write barrier order for `klass` to `cme` edge

            Previously, the following crashes with
            `CFLAGS=-DRGENGC_CHECK_MODE=2 -DRUBY_DEBUG=1 -fno-inline`:

                $ ./miniruby -e 'GC.stress = true; Marshal.dump({})'

            It crashes with a write barrier (WB) miss assertion on an edge from the
            `Hash` class object to a newly allocated negative method entry.

            This is due to usages of vm_ccs_create() running the WB too early,
            before the method entry is inserted into the cc table, so before the
            reference edge is established. The insertion can trigger GC and promote
            the class object, so running the WB after the insertion is necessary.
            Move the insertion into vm_ccs_create() and run the WB after the
            insertion.

            Discovered on CI:
            http://ci.rvm.jp/results/trunk-asserts@ruby-sp2-docker/4391770
            ---
             vm_eval.c       |  3 +--
             vm_insnhelper.c | 10 ++++++----
             vm_method.c     |  3 +--
             3 files changed, 8 insertions(+), 8 deletions(-)

commit cb8d656100659eaee44042ca680886c30892df04
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 09:45:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 09:45:57 +0900

    merge revision(s) a84c99468f26a9f79fec57926d561ed906505eac: [Backport #19575]

            Fix crash in Time on 32-bit systems

            [Bug #19575]

            struct vtm is packed causing it to have a size that is not aligned on
            32-bit systems. When allocating it on the stack, it will have unaligned
            addresses which means that the fields won't be marked by the GC when
            scanning the stack (since the GC only marks aligned addresses). This can
            cause crashes when the fields are heap allocated objects like Bignums.

            This commit moves the flags in struct time_object into struct vtm for
            space efficiency and removes the need for packing.

            This is an example of a crash:

                ruby(rb_print_backtrace+0xd) [0x56848945] ../src/vm_dump.c:785
                ruby(rb_vm_bugreport) ../src/vm_dump.c:1101
                ruby(rb_assert_failure+0x7a) [0x56671857] ../src/error.c:878
                ruby(vm_search_cc+0x0) [0x56666e47] ../src/vm_method.c:1366
                ruby(rb_vm_search_method_slowpath) ../src/vm_insnhelper.c:2090
                ruby(callable_method_entry+0x5) [0x568232d3] ../src/vm_method.c:1406
                ruby(rb_callable_method_entry) ../src/vm_method.c:1413
                ruby(gccct_method_search_slowpath) ../src/vm_eval.c:427
                ruby(gccct_method_search+0x20f) [0x568237ef] ../src/vm_eval.c:476
                ruby(opt_equality_by_mid_slowpath+0x2c) [0x5682388c] ../src/vm_insnhelper.c:2338
                ruby(rb_equal+0x37) [0x566fe577] ../src/object.c:133
                ruby(rb_big_eq+0x34) [0x56876ee4] ../src/bignum.c:5554
                ruby(rb_int_equal+0x14) [0x566f3ed4] ../src/numeric.c:4640
                ruby(rb_int_equal) ../src/numeric.c:4634
                ruby(vm_call0_cfunc_with_frame+0x6d) [0x568303c2] ../src/vm_eval.c:148
                ruby(vm_call0_cfunc) ../src/vm_eval.c:162
                ruby(vm_call0_body) ../src/vm_eval.c:208
                ruby(rb_funcallv_scope+0xd1) [0x56833971] ../src/vm_eval.c:85
                ruby(RB_TEST+0x0) [0x567e8488] ../src/time.c:78
                ruby(eq) ../src/time.c:78
                ruby(small_vtm_sub) ../src/time.c:1523
                ruby(timelocalw+0x23b) [0x567f3e9b] ../src/time.c:1593
                ruby(time_s_alloc+0x0) [0x567f536b] ../src/time.c:3698
                ruby(time_new_timew) ../src/time.c:2694
                ruby(time_s_mktime) ../src/time.c:3698
            ---
             test/ruby/test_time.rb |  7 ++-----
             time.c                 | 57 ++++++++++++++++++++++++--------------------------
             timev.h                |  7 +++++--
             3 files changed, 34 insertions(+), 37 deletions(-)

commit 9fb94407b97bb85ea344e67606f8ae9ba0bdbd48
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-17 09:29:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-17 09:29:04 +0900

    merge revision(s) 417b1a36447cb2c650de55b433ba623541fb8bb3: [Backport #19550]

            Fix memory leak for iclass

            [Bug #19550]

            If !RCLASS_EXT_EMBEDDED (e.g. 32 bit systems) then the rb_classext_t is
            allocated throug malloc so it must be freed.

            The issue can be seen in the following script:

            ```
            20.times do
              100_000.times do
                mod = Module.new
                Class.new do
                  include mod
                end
              end

              # Output the Resident Set Size (memory usage, in KB) of the current Ruby process
              puts `ps -o rss= -p #{$$}`
            end
            ```

            Before this fix, the max RSS is 280MB, while after this change, it's
            30MB.
            ---
             gc.c                     |  2 +-
             test/ruby/test_module.rb | 15 +++++++++++++++
             2 files changed, 16 insertions(+), 1 deletion(-)

commit 45b14ef5c55e5b1956c590f4cfddacbccfc7bf8a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 23:30:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 23:30:43 +0900

    merge revision(s) 7c9ce38cdb781958c52a89b910ee83d5fea99048:

            Remove duplicated Rust installation

            ---
             .cirrus.yml | 6 +-----
             1 file changed, 1 insertion(+), 5 deletions(-)

commit 6feef620c5bfc17548e96227ab08910dd97bb11c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 23:28:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 23:28:37 +0900

    merge revision(s) 4bfa4433830a4e48bc4ca43aef861d213affdd84:

            [Cirrus] Set up cargo environments just once at first

            ---
             .cirrus.yml | 22 +++++++++++-----------
             1 file changed, 11 insertions(+), 11 deletions(-)

commit 35b0f10519afb5446dc1da1ebea440cc1efdc8d9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 23:27:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 23:27:44 +0900

    merge revision(s) 3a761dcc91fcbed828699fcc38017f14a1a2db65,d2ffd0ad3d225b6b9e121278146eae8500e9f259:

            [Cirrus] Show CPU and memory info

            ---
             .cirrus.yml | 6 ++++++
             1 file changed, 6 insertions(+)

            [Cirrus] Share configuration using YAML aliases

            https://cirrus-ci.org/guide/tips-and-tricks/#sharing-configuration-between-tasks
            ---
             .cirrus.yml | 113 ++++++++++++++++++------------------------------------------
             1 file changed, 33 insertions(+), 80 deletions(-)

commit e14280fa25b085a1c9521d45064529984f5c6324
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 23:20:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 23:20:16 +0900

    merge revision(s) bde3b98a6040800e05c9cf448228f094f80b8fed:

            [Cirrus] Make gem download non-verbose

            ---
             .cirrus.yml | 16 ++++++++--------
             1 file changed, 8 insertions(+), 8 deletions(-)

commit 88cd13999251797b9a0563123a9bf130197e230b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 18:59:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 18:59:17 +0900

    merge revision(s) 37513490442322e82961bf6d06c1c86d55cb3830:

            [Cirrus] Cache the bundled gems in advance

            ---
             .cirrus.yml | 19 +++++++++++++++++++
             1 file changed, 19 insertions(+)

commit c911cbd6c3dcc80def61ab48be1815cd910fc91b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 16:50:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 16:50:13 +0900

    merge revision(s) bd786e78969f9d4a8699376ceafe10934b6ad533: [Backport #19084]

            Fix mutation on shared strings. (#7837)

            ---
             io_buffer.c                 | 19 ++++++++++++-------
             test/ruby/test_io_buffer.rb |  4 ----
             2 files changed, 12 insertions(+), 11 deletions(-)

commit 5ad2390b551f4a28ea3d4db78c21863489fdd681
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 16:44:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 16:44:22 +0900

    merge revision(s) 466aa8010fb49f9ec6c78ea1de4e8ca0965f4fdf: [Backport #19546]

            Fix incorrect usage of `rb_fiber_scheduler_io_(p)(read|write)`.
             (#7593)

            ---
             io_buffer.c                  |  8 ++++----
             scheduler.c                  | 48 ++++++++++++++++++++++----------------------
             test/fiber/test_io_buffer.rb | 33 ++++++++++++++++++++++++++++++
             3 files changed, 61 insertions(+), 28 deletions(-)

commit c13757ed9ae02a2d03aea91bb852397aa920f3fd
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 16:42:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 16:42:12 +0900

    merge revision(s) 09295ea796900fb7b05d29e93364090e21598566: [Backport #19543]

            IO::Buffer#resize: Free internal buffer if new size is zero (#7569)

            `#resize(0)` on an IO::Buffer with internal buffer allocated will
            result in calling `realloc(data->base, 0)`. The behavior of `realloc`
            with size = 0 is implementation-defined (glibc frees the object
            and returns NULL, while BSDs return an inaccessible object). And
            thus such usage is deprecated in standard C (upcoming C23 will make it
            UB).

            To avoid this problem, just `free`s the memory when the new size is zero.
            ---
             io_buffer.c                 |  5 +++++
             test/ruby/test_io_buffer.rb | 18 ++++++++++++++++++
             2 files changed, 23 insertions(+)

commit 141402d11c09fa641eebd8f4841f81e7bbf3518c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 12:58:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 12:58:21 +0900

    merge revision(s) e1bd45624c85e8a80991bda20801f50967ac77a1: [Backport #19482]

            Fix crash when allocating classes with newobj hook

            We need to zero out the whole slot when running the newobj hook for a
            newly allocated class because the slot could be filled with garbage,
            which would cause a crash if a GC runs inside of the newobj hook.

            For example, the following script crashes:

            ```
            require "objspace"

            GC.stress = true

            ObjectSpace.trace_object_allocations {
              100.times do
                Class.new
              end
            }
            ```

            [Bug #19482]
            ---
             gc.c                           | 8 +++++++-
             test/objspace/test_objspace.rb | 7 +++++++
             2 files changed, 14 insertions(+), 1 deletion(-)

commit b13db31ce8cb8c3a763cc41a6ff616be363ef14a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 11:46:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 11:46:04 +0900

    merge revision(s) fe42d88ad28df395111cfb9f2f67e21910083df1:

            Pass -Werror=lto-type-mismatch for GCC LTO jobs

            This helps to find possible LTO miscompilations earlier. See also
            https://github.com/ruby/ruby/pull/7695.
            ---
             .github/workflows/compilers.yml | 12 ++++++------
             1 file changed, 6 insertions(+), 6 deletions(-)

commit 3e664c58133a5954de878e138854447e945b8246
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 11:43:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 11:43:54 +0900

    merge revision(s) 27a21ad201b04f9af6c206836b4c7543fb69a1e7:

            give up checking old compilers

            These old compilers needed old OSes, which are getting EODed.  We
            cannot maintain healthy binary of them (building compilers on our
            own is quite haed).  Let us just retire them.  Fixes [Bug #19353]
            ---
             .github/workflows/compilers.yml | 6 ------
             1 file changed, 6 deletions(-)

commit 293a00e622da077cd6fad2e4055eb15b081fc2a6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 11:25:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 11:25:45 +0900

    merge revision(s) 33edcc112081f96856d52e73253d73c97a5c4a3c,b4e438d8aabaf4bba2b27f374c787543fae07c58: [Backport #19483]

            YJIT: Protect strings from GC on String#<< (#7466)

            Fix https://github.com/Shopify/yjit/issues/310

            [Bug #19483]

            Co-authored-by: Maxime Chevalier-Boisvert <maxime.chevalierboisvert@shopify.com>
            Co-authored-by: Jimmy Miller <jimmy.miller@shopify.com>
            ---
             yjit/src/codegen.rs | 3 +++
             1 file changed, 3 insertions(+)

            YJIT: Save PC on rb_str_concat (#7586)

            [Bug #19483]

            Co-authored-by: Alan Wu <alansi.xingwu@shopify.com>
            ---
             test/ruby/test_yjit.rb | 19 +++++++++++++++++++
             yjit/src/codegen.rs    |  6 ++++--
             2 files changed, 23 insertions(+), 2 deletions(-)

commit 0ba10fd8508b1a2bf7488649ee90622de9bef04a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-16 11:22:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-16 11:25:45 +0900

    merge revision(s) 132934b82baad97107fe754d60f9a68a1db7ecda: [Backport #19463]

            YJIT: Generate Block::entry_exit with block entry PC

            Previously, when Block::entry_exit is requested from any instruction
            that is not the first one in the block, we generated the exit with an
            incorrect PC. We should always be using the PC for the entry of the
            block for Block::entry_exit.

            It was a simple typo. The bug was [introduced][1] while we were
            refactoring to use the current backend. Later, we had a chance to spot
            this issue while [preparing][2] to enable unused variable warnings, but
            didn't spot the issue.

            Fixes [Bug #19463]

            [1]: 27fcab995e6dde19deb91dc6e291bdb72100af68
            [2]: 31461c7e0eab4963ccc8649ea8ebf27979132c0c
            ---
             test/ruby/test_yjit.rb | 41 +++++++++++++++++++++++++++++++++++++++++
             yjit/src/codegen.rs    |  4 ++--
             2 files changed, 43 insertions(+), 2 deletions(-)

commit 2f603bc4d750384d57513679ca9db2b4e2e3ec34
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2023-07-05 00:07:18 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-07-05 00:07:18 +0900

    ruby_3_2 backport for #8006 (#8008)

    YJIT: Fix autosplat miscomp for blocks with optionals

    When passing an array as the sole argument to `yield`, and the yieldee
    takes more than 1 optional parameter, the array is expanded similar
    to `*array` splat calls. This is called "autosplat" in
    `setup_parameters_complex()`.

    Previously, YJIT did not detect this autosplat condition. It passed the
    array without expanding it, deviating from interpreter behavior.
    Detect this conditon and refuse to compile it.

commit 07d5709feea0b4d4fe23e2f346383791c614f073
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-01 14:18:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-01 14:18:06 +0900

    bump patchlevel

commit 038913f1e9dd4efdbea4047b3e0a3e15f407dfd2
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2023-06-03 04:26:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-01 14:17:30 +0900

    Add missing write barrier

    We were missing the write barrier for class_value to cref. This should
    fix the segv we were seeing in http://ci.rvm.jp/logfiles/brlog.trunk-gc-asserts.20230601-165052

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

commit 8a3d57971c99680d4baec84553247b9c6ee41080
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2023-02-08 05:46:50 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-01 14:17:30 +0900

    Fix cvar caching when class is cloned

    The class variable cache that was added in
    https://github.com/ruby/ruby/pull/4544 changed the behavior of class
    variables on cloned classes. As reported when a class is cloned AND a
    class variable was set, and the class variable was read from the
    original class, reading a class variable from the cloned class would
    return the value from the original class.

    This was happening because the IC (inline cache) is stored on the ISEQ
    which is shared between the original and cloned class, therefore they
    share the cache too.

    To fix this we are now storing the `cref` in the cache so that we can
    check if it's equal to the current `cref`. If it's different we don't
    want to read from the cache. If it's the same we do. Cloned classes
    don't share the same cref with their original class.

    This will need to be backported to 3.1 in addition to 3.2 since the bug
    exists in both versions.

    We also added a marking function which was missing.

    Fixes [Bug #19379]

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

commit 06dae46036316e6e9926c4613ac8058b78eb7f2e
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2023-02-09 05:27:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-01 14:17:30 +0900

    Copy cvar table on clone

    When a class with a class variable is cloned we need to also copy the
    cvar cache table from the original table to the clone. I found this bug
    while working on fixing [Bug #19379]. While this does not fix that bug
    directly it is still a required change to fix another bug revealed by
    the fix in https://github.com/ruby/ruby/pull/7265

    This needs to be backported to 3.2.x and 3.1.x.

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

commit 814271b2f7e20dd3da13f30a2fdc823c720110ac
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-07-01 13:48:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-01 13:48:08 +0900

    bump patchlevel

commit bbf1eb40977441cbe5d1748bbadaf5d46414e170
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-06-21 14:13:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-01 13:46:09 +0900

    Merge URI-0.12.2 for Bundler

commit dd73fe077cae077808e820f4765a12b1f4660521
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-06-21 13:20:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-07-01 13:46:09 +0900

    Merge URI-0.12.2

commit b422c3523c419b88c6da23a4022ae8864f411b84
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-06-25 15:20:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-06-25 15:20:43 +0900

    merge revision(s) 7bd7aee02e303de27d2cddfc5ef47e612d6782cb: [Backport #18464]

            Fix interpreter crash caused by RUBY_INTERNAL_EVENT_NEWOBJ + Ractors

            When a Ractor is created whilst a tracepoint for
            RUBY_INTERNAL_EVENT_NEWOBJ is active, the interpreter crashes. This is
            because during the early setup of the Ractor, the stdio objects are
            created, which allocates Ruby objects, which fires the tracepoint.
            However, the tracepoint machinery tries to dereference the control frame
            (ec->cfp->pc), which isn't set up yet and so crashes with a null pointer
            dereference.

            Fix this by not firing GC tracepoints if cfp isn't yet set up.
            ---
             gc.c                         |  1 +
             test/objspace/test_ractor.rb | 17 +++++++++++++++++
             2 files changed, 18 insertions(+)
             create mode 100644 test/objspace/test_ractor.rb

commit 0c00fb5d92dbd87bfdde393d1e3bece9b457d17c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-06-25 12:37:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-06-25 12:37:14 +0900

    merge revision(s) ec14861f0d7a1e99d3e6667dee2f4c9cc426d5f3:

            Update to ruby/spec@7e680fa

            ---
             spec/ruby/core/dir/home_spec.rb      | 5 +++--
             spec/ruby/core/process/spawn_spec.rb | 2 +-
             2 files changed, 4 insertions(+), 3 deletions(-)

commit e3d10dedf106357d2b17fc8786d35035e0b366cf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-06-25 12:29:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-06-25 12:29:49 +0900

    merge revision(s) bffadcd6d46ccfccade79ce0efb60ced8eac4483: [Backport #19529]

            Add guard to compaction test in WeakMap

            Some platforms don't support compaction, so we should skip this test.
            ---
             test/ruby/test_weakmap.rb | 2 ++
             1 file changed, 2 insertions(+)

commit 3ebcbb537d7ae37e49c49e05b28d2cc5b324f151
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-06-25 12:26:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-06-25 12:26:20 +0900

    merge revision(s) 548086b34e3dd125edabf5dc1e46b891fad3ea9c,3dc8cde70078ccb38f5f4b0818ad5eecded01bd5,e0cf80d666d4b5df3229f030a16d10d21323508e: [Backport #19529]

            ObjectSpace::WeakMap: fix compaction support

            [Bug #19529]

            `rb_gc_update_tbl_refs` can't be used on `w->obj2wmap` because it's
            not a `VALUE -> VALUE` table, but a `VALUE -> VALUE *` table, so
            we need some dedicated iterator.
            ---
             test/ruby/test_weakmap.rb |  8 ++++++++
             weakmap.c                 | 37 ++++++++++++++++++++++++++++++++++++-
             2 files changed, 44 insertions(+), 1 deletion(-)

            Fix crash during compaction

            [Bug #19529]

            The fix for [Bug #19529] in commit 548086b contained a bug that crashes
            on the following script:

            ```
            wm = ObjectSpace::WeakMap.new
            obj = Object.new
            100.times do
              wm[Object.new] = obj
              GC.start
            end
            GC.compact
            ```
            ---
             test/ruby/test_weakmap.rb | 10 ++++++++++
             weakmap.c                 |  2 +-
             2 files changed, 11 insertions(+), 1 deletion(-)

            Fix incorrect size of WeakMap buffer

            In wmap_final_func, j is the number of elements + 1 (since j also
            includes the length at the 0th index), so we should resize the buffer
            to size j and the new length is j - 1.
            ---
             weakmap.c | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit a048f7882a13e96080021a5bc13ef1fb293b4985
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-06-25 11:52:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-06-25 11:52:21 +0900

    merge revision(s) 1cdf8ab07b24ebd16e93621957196e8b1d67f2ba: [Backport #19323]

            [Bug #19323] Raise `RangeError` instead of integer overflow

            ---
             bignum.c                  |  5 ++++-
             test/ruby/test_integer.rb | 18 ++++++++----------
             2 files changed, 12 insertions(+), 11 deletions(-)

commit 9fca561980c6d024229d72600180b20f3f77536f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2023-06-24 16:59:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2023-06-24 16:59:30 +0900

    merge revision(s) cd5e6cc0ea48353c88d921b885b552dc76da255c,bbf54ec334fe2edd7669a944d88d17efde49a412: [Backport #19307]

            Update to ruby/mspec@fef9b81

            ---
             spec/mspec/tool/tag_from_output.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            Update to ruby/spec@9d69b95

            ---
             spec/ruby/core/array/keep_if_spec.rb               |   1 +
             spec/ruby/core/array/pack/c_spec.rb                |  14 +-
             spec/ruby/core/array/pack/shared/basic.rb          |  40 ++++
             spec/ruby/core/array/pack/shared/float.rb          |  66 ++++++-
             spec/ruby/core/array/pack/shared/integer.rb        |  96 +++++++--
             spec/ruby/core/array/pack/shared/numeric_basic.rb  |  10 +-
             spec/ruby/core/array/pack/shared/unicode.rb        |  14 +-
             spec/ruby/core/array/pack/w_spec.rb                |  14 +-
             spec/ruby/core/array/shared/unshift.rb             |  18 ++
             spec/ruby/core/array/values_at_spec.rb             |   1 +
             spec/ruby/core/array/zip_spec.rb                   |   6 +
             spec/ruby/core/class/subclasses_spec.rb            |  22 +++
             spec/ruby/core/dir/home_spec.rb                    |  44 +++--
             spec/ruby/core/dir/mkdir_spec.rb                   |  18 +-
             spec/ruby/core/enumerable/zip_spec.rb              |   5 +
             spec/ruby/core/float/comparison_spec.rb            |  35 ++--
             spec/ruby/core/float/divmod_spec.rb                |   2 +-
             spec/ruby/core/float/gt_spec.rb                    |  21 ++
             spec/ruby/core/float/gte_spec.rb                   |  21 ++
             spec/ruby/core/float/lt_spec.rb                    |  21 ++
             spec/ruby/core/float/lte_spec.rb                   |  21 ++
             spec/ruby/core/float/shared/equal.rb               |  21 ++
             spec/ruby/core/io/gets_spec.rb                     |   4 +
             spec/ruby/core/io/lineno_spec.rb                   |   9 +-
             spec/ruby/core/io/new_spec.rb                      |   2 +
             spec/ruby/core/io/readline_spec.rb                 |   4 +
             spec/ruby/core/io/readlines_spec.rb                |   4 +
             spec/ruby/core/io/shared/each.rb                   |   4 +
             spec/ruby/core/io/shared/new.rb                    |   2 +
             spec/ruby/core/io/shared/pos.rb                    |   8 +-
             spec/ruby/core/io/shared/readlines.rb              |   4 +
             spec/ruby/core/io/sysseek_spec.rb                  |   2 +-
             spec/ruby/core/kernel/shared/load.rb               |  31 ++-
             spec/ruby/core/kernel/singleton_class_spec.rb      |   2 +
             spec/ruby/core/marshal/dump_spec.rb                |  45 ++++-
             spec/ruby/core/marshal/fixtures/classes.rb         |   4 +
             spec/ruby/core/matchdata/values_at_spec.rb         |  73 ++++++-
             spec/ruby/core/module/fixtures/classes.rb          |   1 +
             spec/ruby/core/module/include_spec.rb              |   4 +-
             spec/ruby/core/module/prepend_spec.rb              |  12 ++
             .../ruby/core/objectspace/define_finalizer_spec.rb |  22 +++
             spec/ruby/core/process/constants_spec.rb           |   1 +
